<?php
/**
 * @version $Id: joobb.php 598 2009-09-05 13:25:34Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2009 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */
 
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

/**
 * Joo!BB Controller
 *
 * @package Joo!BB
 */
class JoobbController extends JController
{
	/**
	 * display joobb
	 */
	function display() {

		// initialize variables
		$document		=& JFactory::getDocument();
		$joobbConfig	=& JoobbConfig::getInstance();
		$messageQueue	=& JoobbMessageQueue::getInstance();
		$Itemid 		= JoocmHelper::getItemId('com_joobb');
		
		if (!$joobbConfig->getBoardSettings('published') && JRequest::getVar('info') != 'board_offline') {
			$this->setRedirect(JRoute::_('index.php?option=com_joobb&view=information&info=board_offline&Itemid='. $Itemid, false));
			return;
		}

		$viewName	= JRequest::getVar('view', 'board');
		$viewType	= $document->getType();

		$view = &$this->getView($viewName, $viewType);
		
		// set the layout
		$view->setLayout('joobb');
				
		$model = &$this->getModel($viewName);
		if (!JError::isError($model)) {
			$view->setModel($model, true);
		}

		// assign document
		$view->assignRef('document', $document);
		
		// add style
		$document->addStyleSheet(JoobbHelper::getStyleSheet(true));
		
		// add template path
		$view->addTemplatePath(JoobbHelper::getTemplatePath().DL.'controller');	
		$view->addTemplatePath(JoobbHelper::getTemplatePath());

		/**
		 * ToDo: find a better solution!
		 */
				
		// add template language
		$langFile = JoobbHelper::getTemplatePath().DS.'language'.DS.JoobbHelper::getLocale().DS.str_replace('.xml', '.ini', $joobbConfig->getTemplateFile());
		
		if (!is_file($langFile)) {
			$langFile = JoobbHelper::getTemplatePath().DS.'language'.DS.'en-GB'.DS.str_replace('.xml', '.ini', $joobbConfig->getTemplateFile());	
		}
		
		$lang =& JFactory::getLanguage();
		$lang->_load($langFile); // sorry for calling private function, but there is no other solution at the moment!!!
	
		// assign layout
		$view->assignRef('layout', $joobbConfig->getLayoutName());
		
		// assign item params
		$menu =& JSite::getMenu();
		$item = $menu->getActive();
		$params = new JParameter($item->params);
		$view->assignRef('params', $params);

		// assign style sheet path
		$view->assign('styleSheetPath', JoobbHelper::getStyleSheetPath());
				
		// assign style sheet path live
		$view->assign('styleSheetPathLive', JoobbHelper::getStyleSheetPath(true));
		
		// assign template path
		$view->assign('templatePath', JoobbHelper::getTemplatePath());
		
		// assign template path live
		$view->assign('templatePathLive', JoobbHelper::getTemplatePath(true));
		
		// assign board name	
		$view->assign('boardName', $joobbConfig->getBoardSettings('board_name'));
		
		// assign allow user registration
		$usersConfig = &JComponentHelper::getParams('com_users');
		$view->assign('allowUserRegistration', $usersConfig->get('allowUserRegistration'));
		
		// assign some global variables
		$view->assign('showBoxLatestItems', $joobbConfig->getViewSettings('show_latestitems'));
		$view->assign('showBoxStatistic', $joobbConfig->getViewSettings('show_statistic'));
		$view->assign('showBoxWhosOnline', $joobbConfig->getViewSettings('show_whosonline'));
		$view->assign('showBoxLegend', $joobbConfig->getViewSettings('show_legend'));
		$view->assign('showBoxFooter', $joobbConfig->getViewSettings('show_footer'));
	
		// assign bread crumb
		$breadCrumbs =& JoobbBreadCrumbs::getInstance();
		$breadCrumbUrl = JRoute::_('index.php?option=com_joobb&view=board&Itemid='.$Itemid);
		$breadCrumbs->addBreadCrumb($joobbConfig->getBoardSettings('breadcrumb_index'), $breadCrumbUrl);
		$view->assignRef('breadCrumbs', $breadCrumbs);
		
		// assign current url
		if ($viewName != 'login') {
			$uri = JUri::getInstance();
			$view->assign('redirect', $uri->toString());
		} else {
			$view->assign('redirect', JRequest::getVar('redirect'));
		}

		// assign joobb config
		$view->assignRef('joobbConfig', $joobbConfig);
		
		// assign joobb message queue
		$view->assignRef('messageQueue', $messageQueue);
				
		// assign current time
		$currentTime = JoocmHelper::Date(gmdate("Y-m-d H:i:s"));
		$view->assignRef('currentTime', $currentTime);
		
		// assign current time zone name
		$currentTimeZoneName = JoocmHelper::getCurrentTimeZoneName();
		$view->assignRef('currentTimeZoneName', $currentTimeZoneName);		
		
		// assign current joobb user
		$joobbUser =& JoobbHelper::getJoobbUser();
		$view->assignRef('joobbUser', $joobbUser);

		// assign item id
		$view->assign('Itemid', $Itemid);

		// display the view
		$view->assign('error', $this->getError());
		$view->display();

	}
	
	/**
	 * preview post (topic or post)
	 */
	function joobbPreview() {
		global $mainframe, $Itemid;
		
		// initialize variables
		$task			= JRequest::getVar('task');
		$post			= JRequest::get('post');
		
		$session =& JFactory::getSession();
		$session->set('joobbPost', $post);

		switch ($task) {
			case 'joobbpreviewtopic':
				if ($post['id_post'] == 0) {
					$link = JRoute::_('index.php?option=com_joobb&view=edittopic&forum='.(int)$post['id_forum'].'&topic='.(int)$post['id_topic'].'&Itemid='.$Itemid, false);
				} else {
					$link = JRoute::_('index.php?option=com_joobb&view=edittopic&topic='.(int)$post['id_topic'].'&post='.(int)$post['id_post'].'&Itemid='.$Itemid, false);
				}
				break;
			case 'joobbpreviewpost':
				$link = JRoute::_('index.php?option=com_joobb&view=editpost&topic='.(int)$post['id_topic'].'&post='.(int)$post['id_post'].'&Itemid='.$Itemid, false);
				break;
			default:
				$link = JRoute::_('index.php?option=com_joobb&view=board&Itemid='.$Itemid, false);
				break;
		}

		$this->setRedirect($link);
	}
	
	/**
	 * save the topic
	 */
	function joobbSaveTopic() {
		global $mainframe, $Itemid;

		// initialize variables
		$db				=& JFactory::getDBO();
		$joobbConfig	=& JoobbConfig::getInstance();
		$joobbUser		=& JoobbHelper::getJoobbUser();
		$messageQueue	=& JoobbMessageQueue::getInstance();
		$task			= JRequest::getVar('task');
		$post			= JRequest::get('post');
		
		// flood interval
		$time = JoobbHelper::getLastPostTimeByIP($_SERVER['REMOTE_ADDR']);
		if (isset($time)) {
			$floodInterval = $joobbConfig->getBoardSettings('flood_interval');
			if ((strtotime(gmdate("Y-m-d H:i:s")) - strtotime($time)) < $floodInterval) {
				$messageQueue->addMessage(sprintf(JText::_('BB_MSGFLOODINTERVAL'), $floodInterval));
				$link = JRoute::_('index.php?option=com_joobb&view=edittopic&forum='.(int)$post['id_forum'].'&topic='.(int)$post['id_topic'].'&Itemid='.$Itemid, false);
				$this->setRedirect($link);
				return;
			}
		}
		
		// check authorization to prevent spoofing and hacking
		$joobbAuth =& JoobbAuth::getInstance();
		if (!$joobbAuth->getAuth('auth_post', (int)$post['id_forum'])) {
			$link = JRoute::_('index.php?option=com_joobb&view=forum&forum='. (int)$post['id_forum'] .'&Itemid='.$Itemid, false);
			$joobbForum =& JTable::getInstance('JoobbForum');
			$joobbForum->load((int)$post['id_forum']);
			$msg = sprintf( JText::_('BB_MSGNOACCESSPOST'), $joobbForum->name);
			$messageQueue->addMessage($msg);
			$this->setRedirect($link);
			return;
		}

		$id_topic = (int)$post['id_topic'];
		$isNew = ($id_topic < 1);

		$joobbTopic =& JTable::getInstance('JoobbTopic');
		if (!$joobbTopic->bind($post)) {
			$messageQueue->addMessage($joobbTopic->getError()); return;
		}
		
		$joobbTopic->id = $id_topic;

		if (!$joobbTopic->store()) {
			$messageQueue->addMessage($joobbTopic->getError()); return;
		}

		$joobbPost =& JTable::getInstance('JoobbPost');
		if (!$joobbPost->bind(JRequest::get('post'))) {
			$messageQueue->addMessage($joobbPost->getError()); return;
		}
		
		// we need to request the text separetly, otherwise html tags will be not saved
		$joobbPost->text = JRequest::getVar('text', '', 'post', 'string', JREQUEST_ALLOWRAW);
		
		$joobbPost->id = $post['id_post'];
		
		if ($isNew) {
			$joobbPost->id_topic	= $joobbTopic->id;
			$joobbPost->date_post	= gmdate("Y-m-d H:i:s");
			$joobbPost->id_user		= $joobbUser->get('id');
			$joobbPost->ip_poster = $_SERVER['REMOTE_ADDR'];
		} else {
			$joobbPost->date_last_edit = gmdate("Y-m-d H:i:s");
		}
		
		if (!$joobbPost->store()) {
			$messageQueue->addMessage($joobbPost->getError());
			return;
		}
		
		// rework topic
		if ($isNew) {
			$joobbTopic->id_first_post = $joobbPost->id;
			$joobbTopic->id_last_post = $joobbPost->id;
		}
		
		if (!$joobbTopic->store()) {
			$messageQueue->addMessage($joobbTopic->getError());
			return;
		}
		
		// rework forum
		if ($isNew) {		
			$joobbForum =& JTable::getInstance('JoobbForum');
			$joobbForum->load($joobbTopic->id_forum);
			$joobbForum->posts++;
			$joobbForum->topics++;
			$joobbForum->id_last_post = $joobbPost->id;
			
			if (!$joobbForum->store()) {
				$messageQueue->addMessage($joobbForum->getError()); return;
			}
		
			$userPosts = $joobbUser->get('posts');
			$userPosts++;
			$joobbUser->set('posts', $userPosts);
			$joobbUser->save();
	
		}
		
		// subscribe the topic?
		if ($joobbConfig->getBoardSettings('auto_subscription') && $post['subscribe'] &&
				$joobbPost->id_topic && $joobbPost->id_user) {
			$query = "INSERT INTO #__joobb_topics_subscriptions (id_topic, id_user)"
					. "\n VALUES (". $joobbPost->id_topic .", ". $joobbPost->id_user .")"
					;
			$db->setQuery($query);
			
			if (!$db->query()) {
				$messageQueue->addMessage($db->getError());
			}
		}
		
		// save guest user
		if (isset($post['guest_name'])) {
			$joobbUser->saveGuestUser($joobbPost->id , $post['guest_name']);
		}

		// save attachments
		$attachmentList = JRequest::getVar('attachmentFiles', array(), 'files', 'array');
		$attachmentResult = true;
		if (is_array($attachmentList) && $attachmentList['name'][0] != '') {
			$joobbAttachment =& JoobbAttachment::getInstance();
				
			// upload all selected attachments		
			for ($i=0, $n=count($attachmentList['name']); $i < $n; $i++) {
				$attachment = array();
				$attachment['name'] = $attachmentList['name'][$i];
				$attachment['type'] = $attachmentList['type'][$i];
				$attachment['tmp_name'] = $attachmentList['tmp_name'][$i];
				$attachment['error'] = $attachmentList['error'][$i];
				$attachment['size'] = $attachmentList['size'][$i];
				
				if (!$joobbAttachment->uploadAttachment($attachment, $joobbPost->id)) {
					$attachmentResult = false;
				}
			}
		}

		// do we have any attachments to delete?		
		$attachments = JRequest::getVar('attachments', array(), 'post', 'array');
		if (count($attachments)) {
			$joobbAttachment =& JoobbAttachment::getInstance();
			foreach ($attachments as $attachment) {
				if (!$joobbAttachment->deleteAttachment($attachment)) {
					$attachmentResult = false;
				}
			}
		}
		
		if ($attachmentResult) {
			$messageQueue->addMessage(JText::_('BB_MSGTOPICSAVED'));
			$link = JRoute::_('index.php?option=com_joobb&view=topic&topic='.$joobbTopic->id.'&Itemid='.$Itemid, false);
		} else {
			$link = JRoute::_('index.php?option=com_joobb&view=edittopic&topic='.(int)$post['id_topic'].'&post='.(int)$post['id_post'].'&Itemid='.$Itemid, false);
		}

		$this->setRedirect($link);		
	}
	
	/**
	 * saves the post
	 */
	function joobbSavePost() {
		global $Itemid, $mainframe;

		// initialize variables
		$db				=& JFactory::getDBO();
		$joobbConfig	=& JoobbConfig::getInstance();
		$joobbUser		=& JoobbHelper::getJoobbUser();
		$messageQueue	=& JoobbMessageQueue::getInstance();
		$task			= JRequest::getVar('task');
		$post			= JRequest::get('post');
		
		// flood interval
		$time = JoobbHelper::getLastPostTimeByIP($_SERVER['REMOTE_ADDR']);

		if (isset($time)) {
			$floodInterval = $joobbConfig->getBoardSettings('flood_interval');
			if ((strtotime(gmdate("Y-m-d H:i:s")) - strtotime($time)) < $floodInterval) {
				$messageQueue->addMessage(sprintf(JText::_('BB_MSGFLOODINTERVAL'), $floodInterval));
				$link = JRoute::_('index.php?option=com_joobb&view=editpost&topic='.(int)$post['id_topic'].'&post='.(int)$post['id_post'].'&Itemid='.$Itemid, false);
				$this->setRedirect($link);
				return;
			}
		}
		
		// check authorization to prevent spoofing and hacking
		$joobbAuth =& JoobbAuth::getInstance();
		if (!$joobbAuth->getAuth('auth_reply', (int)$post['id_forum'])) {
			$link = JRoute::_('index.php?option=com_joobb&view=topic&topic='. (int)$post['id_topic'] .'&Itemid='. $Itemid, false);
			$joobbForum =& JTable::getInstance('JoobbForum');
			$joobbForum->load((int)$post['id_forum']);
			$msg = sprintf(JText::_('BB_MSGNOACCESSREPLY'), $joobbForum->name);
			$messageQueue->addMessage($msg);
			$mainframe->redirect($link);
		}

		$isNew = ($post['id_post'] < 1);
		
		$joobbPost = & JTable::getInstance('JoobbPost');
		if (!$joobbPost->bind(JRequest::get('post'))) {
			$messageQueue->addMessage($joobbPost->getError()); return;
		}
		
		// we need to request the text separetly, otherwise html tags will be not saved
		$joobbPost->text = JRequest::getVar('text', '', 'post', 'string', JREQUEST_ALLOWRAW);
	
		$joobbPost->id = $post['id_post'];
		if ($isNew) {
			$joobbPost->date_post = gmdate("Y-m-d H:i:s");
			$joobbPost->id_user		= $joobbUser->get('id');
			$joobbPost->ip_poster = $_SERVER['REMOTE_ADDR'];
		} else {
			$joobbPost->date_last_edit = gmdate("Y-m-d H:i:s");
		}
		
		if (!$joobbPost->subject) {
			$joobbTopic =& JTable::getInstance('JoobbTopic');
			$joobbTopic->load($joobbPost->id_topic);
			$joobbTopicPost = & JTable::getInstance('JoobbPost');
			$joobbTopicPost->load($joobbTopic->id_first_post);
			$joobbPost->subject = 'Re: '. $joobbTopicPost->subject;		
		}

		if (!$joobbPost->store()) {
			$messageQueue->addMessage($post->getError()); return;
		}
	
		if ($isNew) {
		
			// rework topic		
			$joobbTopic =& JTable::getInstance('JoobbTopic');
			$joobbTopic->load($joobbPost->id_topic);
			$joobbTopic->replies++;
			$joobbTopic->id_last_post = $joobbPost->id;

			if (!$joobbTopic->store()) {
				$messageQueue->addMessage($joobbTopic->getError()); return;
			}
			
			// rework forum
			$joobbForum =& JTable::getInstance('JoobbForum');
			$joobbForum->load($joobbPost->id_forum);
			$joobbForum->posts++;
			$joobbForum->id_last_post = $joobbPost->id;
			
			if (!$joobbForum->store()) {
				$messageQueue->addMessage($joobbForum->getError()); return;
			}
				
			$userPosts = $joobbUser->get('posts');
			$userPosts++;
			$joobbUser->set('posts', $userPosts);
			$joobbUser->save();
	
			$joobbMail =& JoobbMail::getInstance();	
			$joobbMail->sendNotifyOnReplyMail($joobbPost);
		}
		
		// subscribe the topic?
		if ($joobbConfig->getBoardSettings('auto_subscription') && $post['subscribe'] &&
				$joobbPost->id_topic && $joobbPost->id_user) {
			$query = "INSERT INTO #__joobb_topics_subscriptions (id_topic, id_user)"
					. "\n VALUES (". $joobbPost->id_topic .", ". $joobbPost->id_user .")"
					;
			$db->setQuery($query);
			
			if (!$db->query()) {
				$messageQueue->addMessage($db->getError());
			}
		}
		
		// save guest user
		if (isset($post['guest_name'])) {
			$joobbUser->saveGuestUser($joobbPost->id , $post['guest_name']);
		}

		// save attachments
		$attachmentList = JRequest::getVar('attachmentFiles', array(), 'files', 'array');
		$attachmentResult = true;
		if (is_array($attachmentList) && $attachmentList['name'][0] != '') {
			$joobbAttachment =& JoobbAttachment::getInstance();
				
			// upload all selected attachments		
			for ($i=0, $n=count($attachmentList['name']); $i < $n; $i++) {
				$attachment = array();
				$attachment['name'] = $attachmentList['name'][$i];
				$attachment['type'] = $attachmentList['type'][$i];
				$attachment['tmp_name'] = $attachmentList['tmp_name'][$i];
				$attachment['error'] = $attachmentList['error'][$i];
				$attachment['size'] = $attachmentList['size'][$i];
				
				if (!$joobbAttachment->uploadAttachment($attachment, $joobbPost->id)) {
					$attachmentResult = false;
				}
			}
		}

		// do we have any attachments to delete?		
		$attachments = JRequest::getVar('attachments', array(), 'post', 'array');
		if (count($attachments)) {
			$joobbAttachment =& JoobbAttachment::getInstance();
			foreach ($attachments as $attachment) {
				if (!$joobbAttachment->deleteAttachment($attachment)) {
					$attachmentResult = false;
				}
			}
		}
		
		if ($attachmentResult) {
			$messageQueue->addMessage(JText::_('BB_MSGPOSTSAVED'));
			$link = JRoute::_('index.php?option=com_joobb&view=topic&topic='.$joobbPost->id_topic.'&Itemid='.$Itemid.'#p'.$joobbPost->id, false);
		} else {
			$link = JRoute::_('index.php?option=com_joobb&view=editpost&topic='.(int)$post['id_topic'].'&post='.(int)$post['id_post'].'&Itemid='.$Itemid, false);
		}

		$this->setRedirect($link);
	}
	
	/**
	 * delete the topic
	 */
	function joobbDeleteTopic() {
		global $Itemid, $mainframe;

		// initialize variables
		$db				=& JFactory::getDBO();
		$joobbConfig	=& JoobbConfig::getInstance();
		$joobbAuth		=& JoobbAuth::getInstance();
		$joobbUser		=& JoobbHelper::getJoobbUser();
		$messageQueue	=& JoobbMessageQueue::getInstance();
		
		// get the topic id
		$topicId = JRequest::getVar('topic', 0, '', 'int');

		$joobbTopic =& JTable::getInstance('JoobbTopic');
		
		if ($joobbTopic->load($topicId)) {
		
			$joobbPost =& JTable::getInstance('JoobbPost');
			
			if ($joobbPost->load($joobbTopic->id_first_post)) {
			
				// check general permission to delete a topic
				if ($joobbAuth->getAuth('auth_delete', $joobbPost->id_forum)) {
				
					$guestTime = $joobbConfig->getBoardSettings('guest_time') * 60;
					
					// check user dependent permission to delete a topic
					if ($joobbUser->get('id') == $joobbPost->id_user && $joobbPost->id_user != 0 || 
							$joobbPost->id_user == 0 && $joobbPost->ip_poster == $_SERVER['REMOTE_ADDR'] && (strtotime(gmdate("Y-m-d H:i:s")) - strtotime($joobbPost->date_post)) < $guestTime ||
							$joobbAuth->getAuth('auth_delete_all', $joobbPost->id_forum)) {
					
						$forumId = $joobbTopic->id_forum;
						$topicLastPostId = $joobbTopic->id_last_post;
			
						// delete all topic depended posts first
						$query = "DELETE FROM #__joobb_posts"
								. "\n WHERE id_topic = $topicId"
								;
						$db->setQuery($query);
						
						if (!$db->query()) {
							$messageQueue->addMessage($db->getErrorMsg());
							return;
						}
						
						$postsDeleted = $db->getAffectedRows();
			
						// delete the topic
						if (!$joobbTopic->delete()) {
							$messageQueue->addMessage($joobbTopic->getError());
							return;
						}
						
						// rework forum
						$joobbForum =& JTable::getInstance('JoobbForum');
						if ($joobbForum->load($forumId)) {
							$joobbForum->posts -= $postsDeleted;
							$joobbForum->topics--;
							if ($joobbForum->id_last_post == $topicLastPostId) {
								$joobbForum->id_last_post = JoobbHelper::getLastPostIdForum($forumId);
							}
							
							if (!$joobbForum->store()) {
								$messageQueue->addMessage($joobbForum->getError());
								return;
							}
						}		
						$msg =  JText::_('BB_MSGTOPICDELETED');
						$link = JRoute::_('index.php?option=com_joobb&view=forum&forum='.$forumId.'&Itemid='.$Itemid, false);
					} else {
						$msg = sprintf(JText::_('BB_MSGNOPERMISSION'), JText::_('BB_MSGDELETETOPIC'));
						$link = JRoute::_('index.php?option=com_joobb&view=forum&forum='.$joobbPost->id_forum.'&Itemid='.$Itemid, false);
					}
				} else {
					$msg = sprintf(JText::_('BB_MSGNOPERMISSION'), JText::_('BB_MSGDELETETOPIC'));
					$link = JRoute::_('index.php?option=com_joobb&view=forum&forum='.$joobbPost->id_forum.'&Itemid='.$Itemid, false);
				}
			} else {
				$msg = sprintf(JText::_('BB_MSGPOSTNOTFOUND'));
				$link = JRoute::_('index.php?option=com_joobb&view=board&Itemid='.$Itemid, false);
			}
		} else {
			$msg = JText::_('BB_MSGTOPICNOTFOUND');
			$link = JRoute::_('index.php?option=com_joobb&view=board&Itemid='.$Itemid, false);			
		}

		$messageQueue->addMessage($msg);
		$this->setRedirect($link);
		
	}
	
	/**
	 * delete the post
	 */
	function joobbDeletePost() {
		global $Itemid, $mainframe;

		// initialize variables
		$db				=& JFactory::getDBO();
		$joobbConfig	=& JoobbConfig::getInstance();
		$joobbAuth		=& JoobbAuth::getInstance();
		$joobbUser		=& JoobbHelper::getJoobbUser();
		$messageQueue	=& JoobbMessageQueue::getInstance();
		
		// get the post id		
		$postId = JRequest::getVar('post', 0, '', 'int');
		
		$joobbPost =& JTable::getInstance('JoobbPost');
		
		if ($joobbPost->load($postId)) {
			
			// check general permission to delete a post
			if ($joobbAuth->getAuth('auth_delete', $joobbPost->id_forum)) {
			
				$guestTime = $joobbConfig->getBoardSettings('guest_time') * 60;
			
				// check user dependent permission to delete a post
				if ($joobbUser->get('id') == $joobbPost->id_user && $joobbPost->id_user != 0 || 
						$joobbPost->id_user == 0 && $joobbPost->ip_poster == $_SERVER['REMOTE_ADDR'] && (strtotime(gmdate("Y-m-d H:i:s")) - strtotime($joobbPost->date_post)) < $guestTime ||
						$joobbAuth->getAuth('auth_delete_all', $joobbPost->id_forum)) {
				
					$topicId = $joobbPost->id_topic;
					$forumId = $joobbPost->id_forum;
						
					// delete the post
					if (!$joobbPost->delete()) {
						$messageQueue->addMessage($joobbPost->getError());
						return;
					}
		
					// rework topic		
					$joobbTopic =& JTable::getInstance('JoobbTopic');
					if ($joobbTopic->load($topicId)) {
						$joobbTopic->replies--;
						if ($joobbTopic->id_last_post == $postId) {
							$joobbTopic->id_last_post = JoobbHelper::getLastPostIdTopic($topicId);
						}
				
						if (!$joobbTopic->store()) {
							$messageQueue->addMessage($joobbTopic->getError());
							return;
						}
					}
					
					// rework forum
					$joobbForum =& JTable::getInstance('JoobbForum');
					if ($joobbForum->load($forumId)) {
						$joobbForum->posts--;
						if ($joobbForum->id_last_post == $postId) {
							$joobbForum->id_last_post = JoobbHelper::getLastPostIdForum($forumId);
						}
						
						if (!$joobbForum->store()) {
							$messageQueue->addMessage($joobbForum->getError());
							return;
						}
					}
					
					$msg = JText::_('BB_MSGPOSTDELETED');
					$link = JRoute::_('index.php?option=com_joobb&view=topic&topic='.$topicId.'&Itemid='.$Itemid, false);
				} else {
					$msg = sprintf(JText::_('BB_MSGNOPERMISSION'), JText::_('BB_MSGDELETEPOST'));
					$link = JRoute::_('index.php?option=com_joobb&view=topic&topic='.$joobbPost->id_topic.'&Itemid='.$Itemid, false);
				}
			} else {
				$msg = sprintf(JText::_('BB_MSGNOPERMISSION'), JText::_('BB_MSGDELETEPOST'));
				$link = JRoute::_('index.php?option=com_joobb&view=topic&topic='.$joobbPost->id_topic.'&Itemid='.$Itemid, false);
			}
		} else {
			$msg = sprintf(JText::_('BB_MSGPOSTNOTFOUND'));
			$link = JRoute::_('index.php?option=com_joobb&view=board&Itemid='.$Itemid, false);
		}
		
		$messageQueue->addMessage($msg);
		$this->setRedirect($link);
	}

	/**
	 * report post
	 */
	function joobbReportPost() {
	
		// initialize variables
		$joobbMail		=& JoobbMail::getInstance();
		$postId			= JRequest::getVar('post', 0, '', 'int');
		$reportComment	= JRequest::getVar('report_comment', '');
		$Itemid			= JRequest::getVar('Itemid');

		if ($joobbMail->sendReportPostMail($postId, $reportComment)) {
			$row =& JTable::getInstance('JoobbPost');
			$row->load($postId);
			$link = JRoute::_('index.php?option=com_joobb&view=topic&topic='.$row->id_topic.'&Itemid='. $Itemid, false);
		} else {
			$link = JRoute::_('index.php?option=com_joobb&view=board&Itemid='. $Itemid, false);
		}
		
		$this->setRedirect($link);		
	}
	
	/**
	 * lock topic
	 */
	function joobbLockTopic() {
	
		// initialize variables
		$messageQueue	=& JoobbMessageQueue::getInstance();
		$topicId		= JRequest::getVar('topic', 0, '', 'int');
		$Itemid			= JRequest::getVar('Itemid');

		$row =& JTable::getInstance('JoobbTopic');
		if ($row->load($topicId)) {
			$row->status = 1;
			$row->store();
		}

		$redirect = JRoute::_('index.php?option=com_joobb&view=topic&topic='.$topicId.'&Itemid='. $Itemid, false);
		$this->setRedirect($redirect);		
	}
	
	/**
	 * unlock topic
	 */
	function joobbUnlockTopic() {
	
		// initialize variables
		$messageQueue	=& JoobbMessageQueue::getInstance();
		$topicId		= JRequest::getVar('topic', 0, '', 'int');
		$Itemid			= JRequest::getVar('Itemid');

		$row =& JTable::getInstance('JoobbTopic');
		if ($row->load($topicId)) {
			$row->status = 0;
			$row->store();
		}
	
		$redirect = JRoute::_('index.php?option=com_joobb&view=topic&topic='.$topicId.'&Itemid='. $Itemid, false);
		$this->setRedirect($redirect);
	}
	
	/**
	 * move topic
	 */
	function joobbMoveTopic() {
	
		// initialize variables
		$db				= & JFactory::getDBO();
		$joobbUser		=& JoobbHelper::getJoobbUser();
		$messageQueue	=& JoobbMessageQueue::getInstance();
		$forumId		= JRequest::getVar('forum', 0, '', 'int');
		$topicId		= JRequest::getVar('topic', 0, '', 'int');
		$Itemid			= JRequest::getVar('Itemid');

		$joobbForumMoveTo =& JTable::getInstance('JoobbForum');
		if (!$joobbForumMoveTo->load($forumId)) {
			$messageQueue->addMessage('BB_MSGFORUMNOTFOUND');
			$this->setRedirect(JRoute::_('index.php?option=com_joobb&view=board&Itemid='. $Itemid, false)); return;	
		}
				
		// check if the user is authorized to make posts in the new forum
		if ($joobbForumMoveTo->auth_post <= $joobbUser->getRole($forumId)) {

			$joobbTopic =& JTable::getInstance('JoobbTopic');
			if (!$joobbTopic->load($topicId)) {
				$messageQueue->addMessage('BB_MSGTOPICNOTFOUND');
				$this->setRedirect(JRoute::_('index.php?option=com_joobb&view=board&Itemid='. $Itemid, false)); return;
			}
	
			$joobbForum =& JTable::getInstance('JoobbForum');
			if (!$joobbForum->load($joobbTopic->id_forum)) {
				$messageQueue->addMessage('BB_MSGFORUMNOTFOUND');
				$this->setRedirect(JRoute::_('index.php?option=com_joobb&view=board&Itemid='. $Itemid, false)); return;	
			}
			
			// check if the user is allowed to move a topic
			if ($joobbForum->auth_move <= $joobbUser->getRole($joobbTopic->id_forum)) {
				$query = "UPDATE #__joobb_topics"
					. "\n SET id_forum = $forumId"
					. "\n WHERE id = $topicId"
					;
				$db->setQuery($query);
		
				if (!$db->query()) {
					$msg = $db->getErrorMsg();
					$messageQueue->addMessage($msg);
				} else {
					$query = "UPDATE #__joobb_posts"
						. "\n SET id_forum = $forumId"
						. "\n WHERE id_topic = $topicId"
						;
					$db->setQuery($query);
					
					if (!$db->query()) {
						$msg = $db->getErrorMsg();
						$messageQueue->addMessage($msg);
					} else {
					
						// make some corrections
						$query = "SELECT max(p.id)"
							. "\n FROM `#__joobb_posts` AS p"
							. "\n WHERE p.id_forum = ". $joobbForum->id
							. "\n LIMIT 1"
							;
						$db->setQuery($query);
						
						$joobbForum->id_last_post = $db->loadResult();
						$joobbForum->posts--; 
						$joobbForum->posts = $joobbForum->posts - $joobbTopic->replies;
						$joobbForum->topics--;
						if (!$joobbForum->store()) {
							$messageQueue->addMessage($joobbForum->getError());
						} else {
							$query = "SELECT max(p.id)"
								. "\n FROM `#__joobb_posts` AS p"
								. "\n WHERE p.id_forum = ". $joobbForumMoveTo->id
								. "\n LIMIT 1"
								;
							$db->setQuery($query);
							
							$joobbForumMoveTo->id_last_post = $db->loadResult();
							$joobbForumMoveTo->posts = $joobbForumMoveTo->posts + $joobbTopic->replies + 1; 
							$joobbForumMoveTo->topics++;
							if (!$joobbForumMoveTo->store()) {
								$messageQueue->addMessage($joobbForumMoveTo->getError());
							} else {
								$messageQueue->addMessage(JText::_('BB_MSGTOPICMOVED'));	
							}
						}	
					}
				}
			} else {
				$msg = sprintf(JText::_('BB_MSGNOPERMISSION'), JText::_('BB_MSGMOVETOPIC'));
				$messageQueue->addMessage($msg);
			}
		} else {
			$msg = sprintf(JText::_('BB_MSGNOPERMISSION'), JText::_('BB_MSGMOVETOPIC'));
			$messageQueue->addMessage($msg);
		}
		
		$redirect = JRoute::_('index.php?option=com_joobb&view=topic&topic='.$topicId.'&Itemid='. $Itemid, false);
		$this->setRedirect($redirect);
	}
	
	/**
	 * subscribe topic
	 */
	function joobbSubscribeTopic() {
	
		// initialize variables
		$db				=& JFactory::getDBO();
		$messageQueue	=& JoobbMessageQueue::getInstance();
		$joobbUser		=& JoobbHelper::getJoobbUser();
		$topicId		= JRequest::getVar('topic', 0, '', 'int');
		$Itemid			= JRequest::getVar('Itemid');
		
		if ($joobbUser->get('id') < 1) {
			$messageQueue->addMessage(JText::_('BB_MSGSUBSCRIPTIONNOTALLOWED'));
			$this->setRedirect(JRoute::_('index.php?option=com_joobb&view=board&Itemid='. $Itemid, false)); return;
		}
		
		$row =& JTable::getInstance('JoobbTopic');
		if ($topicId == 0 || !$row->load($topicId)) {
			$messageQueue->addMessage(JText::_('BB_MSGTOPICNOTFOUND'));
			$this->setRedirect(JRoute::_('index.php?option=com_joobb&view=board&Itemid='. $Itemid, false)); return;
		}
		
		$query = "INSERT INTO #__joobb_topics_subscriptions (id_topic, id_user)"
				. "\n VALUES ($topicId, ". $joobbUser->get('id') .")"
				;
		$db->setQuery($query);
		
		if (!$db->query()) {
			$messageQueue->addMessage($db->getError()); return false;
		}

		$this->setRedirect(JRoute::_('index.php?option=com_joobb&view=topic&topic='.$topicId.'&Itemid='. $Itemid, false));		
	}
	
	/**
	 * unsubscribe topic
	 */
	function joobbUnsubscribeTopic() {
	
		// initialize variables
		$db				=& JFactory::getDBO();
		$messageQueue	=& JoobbMessageQueue::getInstance();
		$joobbUser		=& JoobbHelper::getJoobbUser();
		$topicId		= JRequest::getVar('topic', 0, '', 'int');
		$Itemid			= JRequest::getVar('Itemid');
		
		if ($joobbUser->get('id') < 1) {
			$messageQueue->addMessage(JText::_('BB_MSGUNSUBSCRIPTIONNOTALLOWED'));
			$this->setRedirect(JRoute::_('index.php?option=com_joobb&view=board&Itemid='. $Itemid, false)); return;
		}
		
		$row =& JTable::getInstance('JoobbTopic');
		if ($topicId == 0 || !$row->load($topicId)) {
			$messageQueue->addMessage(JText::_('BB_MSGTOPICNOTFOUND'));
			$this->setRedirect(JRoute::_('index.php?option=com_joobb&view=board&Itemid='. $Itemid, false)); return;
		}
	
		$query = "DELETE FROM #__joobb_topics_subscriptions"
				. "\n WHERE id_topic = $topicId"
				. "\n AND id_user = ". $joobbUser->get('id')
				;
		$db->setQuery($query);
		
		if (!$db->query()) {
			$messageQueue->addMessage($db->getError()); return false;
		}

		$this->setRedirect(JRoute::_('index.php?option=com_joobb&view=topic&topic='.$topicId.'&Itemid='. $Itemid, false));
	}
	
	/**
	 * save settings
	 */
	function joobbSaveSettings() {

		// initialize variables
		$messageQueue	=& JoobbMessageQueue::getInstance();
		$joobbUser		=& JoobbHelper::getJoobbUser();
		$Itemid			= JRequest::getVar('Itemid', 0);
		$redirect		= JRoute::_('index.php?option=com_joobb&view=board&Itemid='. $Itemid, false);
		
		if ($joobbUser->get('id') < 1) {
			$msg = JText::_('BB_MSGNOPERMISSIONEDITSETTINGS');	
		} else {
			$msg = JText::_('BB_MSGSETTINGSSAVED');
			
			if (!$joobbUser->saveSettings(JRequest::get('post'))) {
				$redirect = JRoute::_('index.php?option=com_joobb&view=editsettings&Itemid='.$Itemid, false);
				$msg = JText::_($joobbUser->getError());		
			}
		}

		$messageQueue->addMessage($msg);
		$this->setRedirect($redirect);
	}
	
	/**
	 * feed
	 */
	function joobbFeed() {
	
		// initialize variables
		$joobbFeed = JoobbFeed::getInstance();
		
		echo $joobbFeed->createFeed();		
	}
}
?>