<?php
/**
 * @version $Id: buttonset.php 447 2009-02-02 20:23:47Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2008 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */

jimport('joomla.application.component.controller');

require_once(JPATH_COMPONENT.DS.'views'.DS.'buttonset.php');

/**
 * Joo!BB Button Set Controller
 *
 * @package Joo!BB
 */
class ControllerButtonSet extends JController
{

	/**
	 * compiles a list of button sets
	 */
	function showButtonSets() {
		global $mainframe;
		
		// initialize variables
		$db			=& JFactory::getDBO();
		$context		= 'com_joobb.joobb_buttonset_view';
		$limit			= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart		= $mainframe->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');

		// get default button set
		$query = "SELECT d.button_set"
				. "\n FROM #__joobb_designs AS d"
				. "\n WHERE d.default_design = 1"
				;
		$db->setQuery($query);
		$defaultButtonSet = $db->loadResult();
		
		// list templates
		jimport('joomla.filesystem.folder');
		$buttonSets = JFolder::folders(JOOBB_BUTTONS);
				
		$rows = array();
		foreach ($buttonSets as $buttonSetFolder) {
			$fileList = JFolder::files(JOOBB_BUTTONS.DS.$buttonSetFolder, '.xml');
			foreach ($fileList as $buttonSetFile) {
				if(!$data = JoobbHelper::parseXMLFile(JOOBB_BUTTONS.DS.$buttonSetFolder, $buttonSetFile, 'buttonset')){
					continue;
				} else {
					$data->default_button_set = ($data->file_name == $defaultButtonSet);
					$rows[]  = $data;
				}
			}
		}
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination(count($rows), $limitstart, $limit);
		$rows = array_slice($rows, $pagination->limitstart, $pagination->limit);
		
		ViewButtonSet::showButtonSets($rows, $pagination);	
	}
	
	/**
	 * cancels edit button set operation
	 */
	function cancelEditButtonSet() {
		global $mainframe;
		$link = 'index.php?option=com_joobb&task=joobb_buttonset_view';
		$mainframe->redirect($link);
	}
	
	/**
	 * edit the button set
	 */
	function editButtonSet() {
		global $mainframe;
		
		// initialize variables
		$cid 	= JRequest::getVar('cid', array());

		if (!is_array($cid)) {
			$cid = array();
		}

		$joobbButtonSet = new JoobbButtonSet($cid[0]);
			
		ViewButtonSet::editButtonSet($joobbButtonSet);			
	}
	
	/**
	 * save the button set
	 */	
	function saveButtonSet($task) {
		global $mainframe;

		// initialize variables
		$post	= JRequest::get('post');

		// ToDo: implement code saving button set

		switch ($task) {
			case 'joobb_buttonset_apply':
				$link = 'index.php?option=com_joobb&task=joobb_buttonset_edit&cid[]='. $row->id .'&hidemainmenu=1';
				break;

			case 'joobb_buttonset_save':
			default:
				$link = 'index.php?option=com_joobb&task=joobb_buttonset_view';
				break;
		}

		$msg = JText::sprintf('BB_MSGSUCCESSFULLYSAVED', JText::_('BB_BUTTONSET'), $row->name);
		$mainframe->redirect($link, $msg );
	}
	
	/**
	 * delete the button set
	 */	
	function deleteButtonSet() {
		global $mainframe;

		// initialize variables
		$db		=& JFactory::getDBO();
		$cid	= JRequest::getVar('cid', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);

		// ToDo: implement code deleting button set

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_buttonset_view', $db->getErrorMsg(), 'error');
	}
	
	/**
	 * set button set as default
	 */	
	function defaultButtonSet() {
		global $mainframe;

		// initialize variables
		$cid	= JRequest::getVar('cid', array(), 'post', 'array');

		if (count($cid)) {

			// set the default button set to true
			JoobbHelper::setDefaultButtonSet($cid[0]);
		} else {
			$msg = JText::sprintf('BB_MSGNOSELECTION', JText::_('BB_BUTTONSET'), JText::_('BB_DEFAULT'));
		}

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_buttonset_view', $msg);
	}
	
}
?>