<?php
/**
 * @version $Id: category.php 505 2009-02-22 13:38:53Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2008 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */
 
// no direct access
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT.DS.'views'.DS.'category.php');

/**
 * Joo!BB Category Controller
 *
 * @package Joo!BB
 */
class ControllerCategory extends JController
{

	/**
	 * compiles a list of categories
	 */
	function showCategories() {
		global $mainframe;
		
		// initialize variables
		$db			=& JFactory::getDBO();
		
		$context			= 'com_joobb.joobb_category_view';
		$filter_order		= $mainframe->getUserStateFromRequest("$context.filter_order", 'filter_order', 'c.ordering');
		$filter_order_Dir	= $mainframe->getUserStateFromRequest("$context.filter_order_Dir",	'filter_order_Dir',	'');
		$limit				= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart			= $mainframe->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');
		
		$orderby = "\n ORDER BY $filter_order $filter_order_Dir";
		
		// get the total number of records
		$query = "SELECT COUNT(*)"
				. "\n FROM #__joobb_categories AS c"
				. $orderby
				;		
		$db->setQuery($query);
		$total = $db->loadResult();
		
		// create the pagination object
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);
												
		$query = "SELECT c.*"
				. "\n FROM #__joobb_categories AS c"
				. $orderby
				;
		$db->setQuery($query, $pagination->limitstart, $pagination->limit);
		$rows = $db->loadObjectList();
		
		// parameter list
		$lists = array();
		
		// table ordering
		$lists['filter_order'] = $filter_order;
		$lists['filter_order_Dir']	= $filter_order_Dir;
		
		ViewCategory::showCategories($rows, $pagination, $lists);	
	}
	
	/**
	 * cancels edit category operation
	 */
	function cancelEditCategory() {
		global $mainframe;
		
		// check in category so other can edit it
		$row =& JTable::getInstance('JoobbCategory');
		$row->bind(JRequest::get('post'));
		$row->checkin();
		
		$link = 'index.php?option=com_joobb&task=joobb_category_view';
		$mainframe->redirect($link);
	}
	
	/**
	 * edit the category
	 */
	function editCategory() {
		global $mainframe;
		
		// initialize variables
		$db		=& JFactory::getDBO();
		$user	=& JFactory::getUser();
		$cid 	= JRequest::getVar('cid', array(0));
		
		if (!is_array($cid)) {
			$cid = array(0);
		}

		$row =& JTable::getInstance('JoobbCategory');
		$row->load($cid[0]);

		// is someone else editing this category?
		if (JTable::isCheckedOut($user->get('id'), $row->checked_out)) {
			$link = 'index.php?option=com_joobb&task=joobb_category_view';
			$editingUser =& JFactory::getUser($row->checked_out);
			$msg = JText::sprintf('BB_MSGBEINGEDITTED', JText::_('BB_CATEGORY'), $row->name, $editingUser->name);
			$mainframe->redirect($link, $msg);
		}
		
		// check out category so nobody else can edit it
		$row->checkout($user->get('id'));
		
		// parameter list
		$lists = array();

		// build the html radio buttons for published
		$lists['published'] = JHTML::_('select.booleanlist', 'published', '', $row->published);		
				
		ViewCategory::editCategory($row, $lists);			
	}
	
	/**
	 * save the category
	 */	
	function saveCategory($task) {
		global $mainframe;

		// initialize variables
		$db		=& JFactory::getDBO();
		$post	= JRequest::get('post');
		$row	=& JTable::getInstance('JoobbCategory');

		if (!$row->bind($post)) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		$row->checkin();
		$row->reorder();

		switch ($task) {
			case 'joobb_category_apply':
				$link = 'index.php?option=com_joobb&task=joobb_category_edit&cid[]='. $row->id .'&hidemainmenu=1';
				break;
			case 'joobb_category_save':
			default:
				$link = 'index.php?option=com_joobb&task=joobb_category_view';
				break;
		}
		
		$msg = JText::sprintf('BB_MSGSUCCESSFULLYSAVED', JText::_('BB_CATEGORY'), $row->name);
		$mainframe->redirect($link, $msg);
	}
	
	/**
	 * delete the category
	 */
	function deleteCategory() {
		global $mainframe;

		// initialize variables
		$db			=& JFactory::getDBO();
		$cid		= JRequest::getVar('cid', array(), 'post', 'array');
		$msgType	= '';
		
		JArrayHelper::toInteger($cid);
		
		if (count($cid)) {
			
			// how many categories are there to delete?
			if (count($cid) == 1) {
				$row =& JTable::getInstance('JoobbCategory'); $row->load($cid[0]);
				$msg = JText::sprintf('BB_MSGSUCCESSFULLYDELETED', JText::_('BB_CATEGORY'), $row->name);
			} else {
				$msg = JText::sprintf('BB_MSGSUCCESSFULLYDELETED', JText::_('BB_CATEGORIES'), '');
			}
		
			$query = "DELETE FROM #__joobb_categories"
					. "\n WHERE id = " . implode(' OR id = ', $cid)
					;
			$db->setQuery($query);
			
			if (!$db->query()) {
				$msg = $db->getErrorMsg();
				$msgType = 'error';
			}
		} else {
			$msg = JText::sprintf('BB_MSGNOSELECTION', JText::_('BB_CATEGORY'), JText::_('BB_DELETE'));
		}

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_category_view', $msg, $msgType);
	}
	
	/**
	 * moves the order of category up or down
	 * @param integer increment/decrement
	 */
	function orderCategory($direction) {
		global $mainframe;

		// initialize variables
		$db		= & JFactory::getDBO();
		$cid	= JRequest::getVar('cid', array(), 'post', 'array');

		if (isset($cid[0])) {
			$row =& JTable::getInstance('JoobbCategory');
			$row->load((int) $cid[0]);
			$row->move($direction);
		}
		
		$msg = JText::sprintf('BB_MSGSUCCESSFULLYREORDERED', JText::_('BB_CATEGORY'), $row->name);
		$mainframe->redirect('index.php?option=com_joobb&task=joobb_category_view', $msg);
	}
	
	/**
	 * save the category order 
	 */
	function saveCategoryOrder() {
		global $mainframe;

		// initialize variables
		$db			= & JFactory::getDBO();
		$cid		= JRequest::getVar('cid', array(0), 'post', 'array');
		$order		= JRequest::getVar('order', array (0), 'post', 'array');
		$total		= count($cid);
		$conditions	= array();

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($order, array(0));

		// instantiate a category table object
		$row = & JTable::getInstance('JoobbCategory');

		// update the ordering for items in the cid array
		for ($i = 0; $i < $total; $i ++) {
			$row->load((int) $cid[$i]);
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError(500, $db->getErrorMsg());
					return false;
				}
				
				// remember to update order this group
				$condition = "";
				$found = false;
				foreach ($conditions as $cond)
					if ($cond[1] == $condition) {
						$found = true;
						break;
					}
				if (!$found)
					$conditions[] = array($row->id, $condition);
			}
		}

		// execute updateOrder for each group
		foreach ($conditions as $cond) {
			$row->load($cond[0]);
			$row->reorder($cond[1]);
		}

		$msg = JText::sprintf('BB_MSGSUCCESSFULLYSAVEDORDER', JText::_('BB_CATEGORY'));
		$mainframe->redirect('index.php?option=com_joobb&task=joobb_category_view', $msg);
	}
	
	/**
	 * Changes the publish state of a category
	 * @param integer 0 = unpublishing, 1 = publishing
	 */
	function changeCategoryPublishState($state = 0) {
		global $mainframe;
		
		// initialize variables
		$db			= & JFactory::getDBO();
		$cid		= JRequest::getVar('cid', array(0), 'post', 'array');
		$msgType	= '';
		
		JArrayHelper::toInteger($cid);
		
		if (count($cid)) {
			$msgText = ($state == 1) ? 'BB_MSGSUCCESSFULLYPUBLISHED' : 'BB_MSGSUCCESSFULLYUNPUBLISHED';
			
			// are there one or more rows to publish/unpublish?
			if (count($cid) == 1) {
				$row =& JTable::getInstance('JoobbCategory'); $row->load($cid[0]);
				$msg = JText::sprintf($msgText, JText::_('BB_CATEGORY'), $row->name);
			} else {
				$msg = JText::sprintf($msgText, JText::_('BB_CATEGORIES'), '');
			}

			$query = "UPDATE #__joobb_categories"
					. "\n SET published = $state"
					. "\n WHERE id = " . implode(' OR id = ', $cid)
					;
			$db->setQuery($query);
	
			if (!$db->query()) {
				$msg = $db->getErrorMsg();
				$msgType = 'error';
			}
		}

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_category_view', $msg, $msgType);
	}
			
}
?>