<?php
/**
 * @version $Id: design.php 447 2009-02-02 20:23:47Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2008 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT.DS.'views'.DS.'design.php');

/**
 * Joo!BB Design Controller
 *
 * @package Joo!BB
 */
class ControllerDesign extends JController
{

	/**
	 * compiles a list of designs
	 */
	function showDesigns() {
		global $mainframe;
		
		// initialize variables
		$db			=& JFactory::getDBO();
		
		$context			= 'com_joobb.joobb_design_view';
		$filter_order		= $mainframe->getUserStateFromRequest("$context.filter_order", 'filter_order', 'd.name');
		$filter_order_Dir	= $mainframe->getUserStateFromRequest("$context.filter_order_Dir",	'filter_order_Dir',	'');
		$limit				= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart			= $mainframe->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');

		$orderby = "\n ORDER BY $filter_order $filter_order_Dir";
		
		// get the total number of records
		$query = "SELECT COUNT(*)"
				. "\n FROM #__joobb_designs AS d"
				. $orderby
				;		
		$db->setQuery($query);
		$total = $db->loadResult();
		
		// create the pagination object
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);
													
		$query = "SELECT d.*"
				. "\n FROM #__joobb_designs AS d"
				. $orderby
				;
		$db->setQuery($query, $pagination->limitstart, $pagination->limit);
		$rows = $db->loadObjectList();
		
		// get the design components
		jimport( 'joomla.filesystem.folder' );		

		for ($i=0; $i < count($rows); $i++) {
			if(!$data = JoobbHelper::parseXMLFile(JOOBB_TEMPLATES.DS.basename($rows[$i]->template, ".xml"), $rows[$i]->template, 'template')) {
				continue;
			} else {
				$rows[$i]->template_name = $data->name;
			}
			
			if(!$data = JoobbHelper::parseXMLFile(JOOBB_STYLES.DS.basename($rows[$i]->style, ".xml"), $rows[$i]->style, 'style')) {
				continue;
			} else {
				$rows[$i]->style_name = $data->name;
			}
			
			if(!$data = JoobbHelper::parseXMLFile(JOOBB_EMOTIONS.DS.basename($rows[$i]->emotion_set, ".xml"), $rows[$i]->emotion_set, 'emotionset')) {
				continue;
			} else {
				$rows[$i]->emotion_set_name = $data->name;
			}
			
			if(!$data = JoobbHelper::parseXMLFile(JOOBB_BUTTONS.DS.basename($rows[$i]->button_set, ".xml"), $rows[$i]->button_set, 'buttonset')) {
				continue;
			} else {
				$rows[$i]->button_set_name = $data->name;
			}

			if(!$data = JoobbHelper::parseXMLFile(JOOBB_ICONS.DS.basename($rows[$i]->icon_set, ".xml"), $rows[$i]->icon_set, 'iconset')) {
				continue;
			} else {
				$rows[$i]->icon_set_name = $data->name;
			}
		}
				
		// parameter list
		$lists = array();
		
		// table ordering
		$lists['filter_order'] = $filter_order;
		$lists['filter_order_Dir']	= $filter_order_Dir;
		
		ViewDesign::showDesigns($rows, $pagination, $lists);	
	}
	
	/**
	 * cancels edit design operation
	 */
	function cancelEditDesign() {
		global $mainframe;
		
		// check in design so other can edit it
		$row =& JTable::getInstance('JoobbDesign');
		$row->bind(JRequest::get('post'));
		$row->checkin();

		$link = 'index.php?option=com_joobb&task=joobb_design_view';
		$mainframe->redirect( $link );
	}
	
	/**
	 * edit the design
	 */
	function editDesign() {
		global $mainframe;
		
		// initialize variables
		$db   	=& JFactory::getDBO();
		$user	=& JFactory::getUser();
		$cid 	= JRequest::getVar('cid', array(0));
		
		if (!is_array($cid)) {
			$cid = array(0);
		}

		$row =& JTable::getInstance('JoobbDesign');
		$row->load($cid[0]);

		// is someone else editing this design?
		if (JTable::isCheckedOut($user->get('id'), $row->checked_out)) {
			$link = 'index.php?option=com_joobb&task=joobb_design_view';
			$editingUser =& JFactory::getUser($row->checked_out);
			$msg = JText::sprintf('BB_MSGBEINGEDITTED', JText::_('BB_DESIGN'), $row->name, $editingUser->name);
			$mainframe->redirect($link, $msg);
		}
		
		// check out design so nobody else can edit it
		$row->checkout($user->get('id'));
	
		// we need it for template lists etc. 
		jimport( 'joomla.filesystem.folder' );

		// parameter list
		$lists = array();

		// list template files
		$templatesList = JFolder::folders(JOOBB_TEMPLATES);
				
		$templates = array();
		foreach ($templatesList as $templateFolder) {
			$fileList = JFolder::files(JOOBB_TEMPLATES.DS.$templateFolder, '.xml');
			foreach ($fileList as $templateFile) {
				if(!$data = JoobbHelper::parseXMLFile(JOOBB_TEMPLATES.DS.$templateFolder, $templateFile, 'template')) {
					continue;
				} else {
					$templates[] = JHTML::_('select.option', $data->file_name, $data->name);
				}
			}
		}
		$lists['templates'] = JHTML::_('select.genericlist',  $templates, 'template', 'class="inputbox" size="1"', 'value', 'text', $row->template);

		// list style files
		$stylesList = JFolder::folders(JOOBB_STYLES);
				
		$styles = array();
		foreach ($stylesList as $styleFolder) {
			$fileList = JFolder::files(JOOBB_STYLES.DS.$styleFolder, '.xml');
			foreach ($fileList as $styleFile) {
				if(!$data = JoobbHelper::parseXMLFile(JOOBB_STYLES.DS.$styleFolder, $styleFile, 'style')) {
					continue;
				} else {
					$styles[] = JHTML::_('select.option', $data->file_name, $data->name);
				}
			}
		}
		$lists['styles'] = JHTML::_('select.genericlist',  $styles, 'style', 'class="inputbox" size="1"', 'value', 'text', $row->style);
	
		// list emotion sets
		$emotionSetsList = JFolder::folders(JOOBB_EMOTIONS);
				
		$emotionSets = array();
		foreach ($emotionSetsList as $emotionSetFolder) {
			$fileList = JFolder::files(JOOBB_EMOTIONS.DS.$emotionSetFolder, '.xml');
			foreach ($fileList as $emotionSetFile) {
				if(!$data = JoobbHelper::parseXMLFile(JOOBB_EMOTIONS.DS.$emotionSetFolder, $emotionSetFile, 'emotionset')) {
					continue;
				} else {
					$emotionSets[] = JHTML::_('select.option', $data->file_name, $data->name);
				}
			}
		}
		$lists['emotionsets'] = JHTML::_('select.genericlist',  $emotionSets, 'emotion_set', 'class="inputbox" size="1"', 'value', 'text', $row->emotion_set);		

		// list button sets
		$buttonSetsList = JFolder::folders(JOOBB_BUTTONS);
				
		$buttonSets = array();
		foreach ($buttonSetsList as $buttonSetFolder) {
			$fileList = JFolder::files(JOOBB_BUTTONS.DS.$buttonSetFolder, '.xml');
			foreach ($fileList as $buttonSetFile) {
				if(!$data = JoobbHelper::parseXMLFile(JOOBB_BUTTONS.DS.$buttonSetFolder, $buttonSetFile, 'buttonset')) {
					continue;
				} else {
					$buttonSets[] = JHTML::_('select.option', $data->file_name, $data->name);
				}
			}
		}
		$lists['buttonsets'] = JHTML::_('select.genericlist',  $buttonSets, 'button_set', 'class="inputbox" size="1"', 'value', 'text', $row->button_set);
		
		// list icon sets
		$iconSetsList = JFolder::folders(JOOBB_ICONS);
				
		$iconSets = array();
		foreach ($iconSetsList as $iconSetFolder) {
			$fileList = JFolder::files(JOOBB_ICONS.DS.$iconSetFolder, '.xml');
			foreach ($fileList as $iconSetFile) {
				if(!$data = JoobbHelper::parseXMLFile(JOOBB_ICONS.DS.$iconSetFolder, $iconSetFile, 'iconset')) {
					continue;
				} else {
					$iconSets[] = JHTML::_('select.option', $data->file_name, $data->name);
				}
			}
		}
		$lists['iconsets'] = JHTML::_('select.genericlist',  $iconSets, 'icon_set', 'class="inputbox" size="1"', 'value', 'text', $row->icon_set);

		ViewDesign::editDesign($row, $lists);			
	}
	
	/**
	 * save the design
	 */	
	function saveDesign($task) {
		global $mainframe;

		// initialize variables
		$db 	=& JFactory::getDBO();
		$post	= JRequest::get('post');
		$row 	=& JTable::getInstance('JoobbDesign');

		if (!$row->bind($post)) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		$row->checkin();

		switch ($task) {
			case 'joobb_design_apply':
				$link = 'index.php?option=com_joobb&task=joobb_design_edit&cid[]='. $row->id .'&hidemainmenu=1';
				break;
			case 'joobb_design_save':
			default:
				$link = 'index.php?option=com_joobb&task=joobb_design_view';
				break;
		}
		
		$msg = JText::sprintf('BB_MSGSUCCESSFULLYSAVED', JText::_('BB_DESIGN'), $row->name);
		$mainframe->redirect( $link, $msg );
	}
	
	/**
	 * delete the design
	 */		
	function deleteDesign() {
		global $mainframe;

		// initialize variables
		$db			=& JFactory::getDBO();
		$cid		= JRequest::getVar('cid', array(), 'post', 'array');
		$msgType	= '';
		
		JArrayHelper::toInteger($cid);

		if (count($cid)) {
			
			// how many categories are there to delete?
			if (count($cid) == 1) {
				$row =& JTable::getInstance('JoobbDesign'); $row->load($cid[0]);
				$msg = JText::sprintf('BB_MSGSUCCESSFULLYDELETED', JText::_('BB_DESIGN'), $row->name);
			} else {
				$msg = JText::sprintf('BB_MSGSUCCESSFULLYDELETED', JText::_('BB_DESIGNS'), '');
			}
		
			$query = "DELETE FROM #__joobb_designs"
					. "\n WHERE id = " . implode(' OR id = ', $cid)
					;
			$db->setQuery($query);
			
			if (!$db->query()) {
				$msg = $db->getErrorMsg();
				$msgType = 'error';
			}
		} else {
			$msg = JText::sprintf('BB_MSGNOSELECTION', JText::_('BB_DESIGN'), JText::_('BB_MENUBARDELETE'));
		}

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_design_view', $msg, $msgType);
	}
	
	/**
	 * set design as default
	 */	
	function defaultDesign() {
		global $mainframe;

		// initialize variables
		$db			=& JFactory::getDBO();
		$cid		= JRequest::getVar('cid', array(), 'post', 'array');
		$msgType	= '';
		
		JArrayHelper::toInteger($cid);

		if (count($cid)) {

			// set the default design to true
			JoobbHelper::setDefaultDesign($cid[0]);
			
			// set the default design to the default config	
			$query = "UPDATE #__joobb_configs"
					. "\n SET id_design = $cid[0]"
					. "\n WHERE default_config = 1"
					;
			$db->setQuery($query);
			
			if (!$db->query()) {
				$msg = $db->getErrorMsg();
				$msgType = 'error';
			}
		} else {
			$msg = JText::sprintf('BB_MSGNOSELECTION', JText::_('BB_DESIGN'), JText::_('BB_MENUBARDEFAULT'));
		}

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_design_view', $msg, $msgType);
	}
}
?>