<?php
/**
 * @version $Id: emotionset.php 447 2009-02-02 20:23:47Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2008 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT.DS.'views'.DS.'emotionset.php');

/**
 * Joo!BB Emotion Set Controller
 *
 * @package Joo!BB
 */
class ControllerEmotionSet extends JController
{

	/**
	 * compiles a list of emotion sets
	 */
	function showEmotionSets() {
		global $mainframe;
		
		// initialize variables
		$db			=& JFactory::getDBO();
		$context		= 'com_joobb.joobb_emotionset_view';
		$limit			= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart		= $mainframe->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');

		// get default template
		$query = "SELECT d.emotion_set"
				. "\n FROM #__joobb_designs AS d"
				. "\n WHERE d.default_design = 1"
				;
		$db->setQuery($query);
		$defaultEmotionSet = $db->loadResult();
		
		// list templates
		jimport('joomla.filesystem.folder');
		$emotionSets	= JFolder::folders(JOOBB_EMOTIONS);
				
		$rows = array();
		foreach ($emotionSets as $emotionSetFolder) {
			$fileList = JFolder::files(JOOBB_EMOTIONS.DS.$emotionSetFolder, '.xml');
			foreach ($fileList as $emotionSetFile) {
				if(!$data = JoobbHelper::parseXMLFile(JOOBB_EMOTIONS.DS.$emotionSetFolder, $emotionSetFile, 'emotionset')){
					continue;
				} else {
					$data->default_emotion_set = ($data->file_name == $defaultEmotionSet);
					$rows[]  = $data;
				}
			}
		}
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination(count($rows), $limitstart, $limit);
		$rows = array_slice($rows, $pagination->limitstart, $pagination->limit);
				
		ViewEmotionSet::showEmotionSets($rows, $pagination);	
	}
	
	/**
	 * cancels edit emotion set operation
	 */
	function cancelEditEmotionSet() {
		global $mainframe;
		$link = 'index.php?option=com_joobb&task=joobb_emotionset_view';
		$mainframe->redirect($link);
	}
	
	/**
	 * edit the emotion set
	 */
	function editEmotionSet() {
		global $mainframe;
		
		// initialize variables
		$cid 	= JRequest::getVar('cid', array());

		if (!is_array($cid)) {
			$cid = array();
		}

		$joobbEmotionSet = new JoobbEmotionSet($cid[0]);
		
		ViewEmotionSet::editEmotionSet($joobbEmotionSet);			
	}
	
	/**
	 * save the emotion set
	 */	
	function saveEmotionSet($task) {
		global $mainframe;

		// initialize variables
		$post	= JRequest::get('post');
		
		// ToDo: implement code saving emotion set
		
		switch ($task) {
			case 'joobb_emotionset_apply':
				$link = 'index.php?option=com_joobb&task=joobb_emotionset_edit&cid[]='. $row->id .'&hidemainmenu=1';
				break;

			case 'joobb_emotionset_save':
			default:
				$link = 'index.php?option=com_joobb&task=joobb_emotionset_view';
				break;
		}
		
		$msg = JText::sprintf('BB_MSGSUCCESSFULLYSAVED', JText::_('BB_EMOTIONSET'), $row->name);
		$mainframe->redirect($link, $msg);
	}
	
	/**
	 * delete the emotion set
	 */	
	function deleteEmotionSet() {
		global $mainframe;

		// initialize variables
		$db		=& JFactory::getDBO();
		$cid	= JRequest::getVar('cid', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);

		// ToDo: implement code deleting emotion set

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_emotionset_view', $db->getErrorMsg(), 'error');
	}
	
	/**
	 * set emotion set as default
	 */		
	function defaultEmotionSet() {
		global $mainframe;

		// Initialize variables
		$cid	= JRequest::getVar('cid', array(), 'post', 'array');

		if (count($cid)) {

			// set the default emotion set to true
			JoobbHelper::setDefaultEmotionSet($cid[0]);
		} else {
			$msg = JText::sprintf('BB_MSGNOSELECTION', JText::_('BB_EMOTIONSET'), JText::_('BB_DEFAULT'));
		}

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_emotionset_view');
	}
	
}
?>