<?php
/**
 * @version $Id: forum.php 526 2009-03-10 20:04:51Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2008 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT.DS.'views'.DS.'forum.php');

/**
 * Joo!BB Forum Controller
 *
 * @package Joo!BB
 */
class ControllerForum extends JController
{

	/**
	 * compiles a list of forums
	 */
	function showForums() {
		global $mainframe;
		
		// initialize variables
		$db				=& JFactory::getDBO();

		$context			= 'com_joobb.joobb_forum_view';
		$filter_order		= $mainframe->getUserStateFromRequest("$context.filter_order", 'filter_order', 'c.ordering, f.ordering');
		$filter_order_Dir	= $mainframe->getUserStateFromRequest("$context.filter_order_Dir",	'filter_order_Dir',	'');
		$limit				= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart			= $mainframe->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');
		
		$orderby = "\n ORDER BY $filter_order $filter_order_Dir";
		
		// get the total number of records
		$query = "SELECT COUNT(*)"
				. "\n FROM #__joobb_forums AS f"
				. "\n INNER JOIN #__joobb_categories AS c ON f.id_cat = c.id"
				. $orderby
				;
		$db->setQuery($query);
		$total = $db->loadResult();
	
		// create the pagination object
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);		
		
		$query = "SELECT f.*, c.name AS category"
				. "\n FROM #__joobb_forums AS f"
				. "\n INNER JOIN #__joobb_categories AS c ON f.id_cat = c.id"
				. $orderby
				;
		$db->setQuery($query, $pagination->limitstart, $pagination->limit);
		$rows = $db->loadObjectList();
		
		// parameter list
		$lists = array();
		
		// table ordering
		$lists['filter_order'] = $filter_order;
		$lists['filter_order_Dir']	= $filter_order_Dir;
		
		ViewForum::showForums($rows, $pagination, $lists);	
	}
	
	/**
	 * cancels edit forum operation
	 */
	function cancelEditForum() {
		global $mainframe;
		
		// check in forum so other can edit it
		$row =& JTable::getInstance('JoobbForum');
		$row->bind(JRequest::get('post'));
		$row->checkin();

		$link = 'index.php?option=com_joobb&task=joobb_forum_view';
		$mainframe->redirect($link);
	}
	
	/**
	 * edit the forum
	 */
	function editForum() {
		global $mainframe;
		
		// initialize variables
		$db 	=& JFactory::getDBO();
		$user	=& JFactory::getUser();
		$cid 	= JRequest::getVar('cid', array(0));

		if (!is_array($cid)) {
			$cid = array(0);
		}

		$row =& JTable::getInstance('JoobbForum');
		$row->load($cid[0]);

		// is someone else editing this forum?
		if (JTable::isCheckedOut($user->get('id'), $row->checked_out)) {
			$link = 'index.php?option=com_joobb&task=joobb_forum_view';
			$editingUser =& JFactory::getUser($row->checked_out);
			$msg = JText::sprintf('BB_MSGBEINGEDITTED', JText::_('BB_FORUM'), $row->name, $editingUser->name);
			$mainframe->redirect($link, $msg);
		}
		
		// check out forum so nobody else can edit it
		$row->checkout($user->get('id'));
		
		// initialize fields of a new forum record
		if ($cid[0] < 1) {
			$row->status = 1;	// enabled
			$row->locked = 0;	// not locked
			
			$row->auth_view = 0;		// all
			$row->auth_read = 0;		// all
			$row->auth_post = 1;		// registered
			$row->auth_reply = 1;		// registered
			$row->auth_edit = 1;		// registered
			$row->auth_edit_all = 1;	// administrators
			$row->auth_delete = 1;		// registered
			$row->auth_delete_all = 4;	// administrators
			$row->auth_move = 3;		// moderators
			$row->auth_reportpost = 1;	// registered
			$row->auth_sticky = 3;		// moderators
			$row->auth_lock = 3;		// moderators
			$row->auth_announce = 3;	// moderators
			$row->auth_attachments = 1;	// registered
		}

		// parameter list
		$lists = array();
		
		// list categories		
		$query = "SELECT c.*"
				. "\n FROM #__joobb_categories AS c"
				. "\n ORDER BY c.ordering"
				;
		$db->setQuery( $query );
		$lists['categories'] = JHTML::_('select.genericlist',  $db->loadObjectList(), 'id_cat', 'class="inputbox" size="1"', 'id', 'name', intval($row->id_cat));
				
		// build the html radio buttons for status
		$lists['status'] = JHTML::_('select.booleanlist', 'status', '', $row->status);
		// build the html radio buttons for locked
		$lists['locked'] = JHTML::_('select.booleanlist', 'locked', '', $row->locked);
		
		// get authentification option list
		$joobbAuth =& JoobbAuth::getInstance();
		$authOptionList = $joobbAuth->getAuthOptionList();

		// get last post
		$lastPost =& JTable::getInstance('JoobbPost');
		$lastPost->load($row->id_last_post);
		$query = "SELECT MAX(id)"
				. "\n FROM #__menu AS m"
				. "\n WHERE m.link LIKE 'index.php?option=com_joobb&view=board%'"
				;
		$db->setQuery($query);
		$Itemid = $db->loadResult();
		$itemLink = JRoute::_(JURI::root().'index.php?option=com_joobb&view=topic&topic='.$lastPost->id_topic.'&Itemid='.$Itemid.'#p'.$lastPost->id);
		$row->last_post_href ='<a href="'.$itemLink.'" target="_blank">'.$lastPost->subject.'</a>';
		
		$lists['auth_view'] = JHTML::_('select.genericlist', $authOptionList, 'auth_view', 'class="inputbox" size="1"', 'value', 'text', intval($row->auth_view));
		$lists['auth_read'] = JHTML::_('select.genericlist', $authOptionList, 'auth_read', 'class="inputbox" size="1"', 'value', 'text', intval($row->auth_read));
		$lists['auth_post'] = JHTML::_('select.genericlist', $authOptionList, 'auth_post', 'class="inputbox" size="1"', 'value', 'text', intval($row->auth_post));
		$lists['auth_reply'] = JHTML::_('select.genericlist', $authOptionList, 'auth_reply', 'class="inputbox" size="1"', 'value', 'text', intval($row->auth_reply));
		$lists['auth_edit'] = JHTML::_('select.genericlist', $authOptionList, 'auth_edit', 'class="inputbox" size="1"', 'value', 'text', intval($row->auth_edit));
		$lists['auth_edit_all'] = JHTML::_('select.genericlist', $authOptionList, 'auth_edit_all', 'class="inputbox" size="1"', 'value', 'text', intval($row->auth_edit_all));
		$lists['auth_delete'] = JHTML::_('select.genericlist', $authOptionList, 'auth_delete', 'class="inputbox" size="1"', 'value', 'text', intval($row->auth_delete));
		$lists['auth_delete_all'] = JHTML::_('select.genericlist', $authOptionList, 'auth_delete_all', 'class="inputbox" size="1"', 'value', 'text', intval($row->auth_delete_all));
		$lists['auth_move'] = JHTML::_('select.genericlist', $authOptionList, 'auth_move', 'class="inputbox" size="1"', 'value', 'text', intval($row->auth_move));
		$lists['auth_reportpost'] = JHTML::_('select.genericlist', $authOptionList, 'auth_reportpost', 'class="inputbox" size="1"', 'value', 'text', intval($row->auth_reportpost));
		$lists['auth_sticky'] = JHTML::_('select.genericlist', $authOptionList, 'auth_sticky', 'class="inputbox" size="1"', 'value', 'text', intval($row->auth_sticky));
		$lists['auth_lock'] = JHTML::_('select.genericlist', $authOptionList, 'auth_lock', 'class="inputbox" size="1"', 'value', 'text', intval($row->auth_lock));
		$lists['auth_announce'] = JHTML::_('select.genericlist', $authOptionList, 'auth_announce', 'class="inputbox" size="1"', 'value', 'text', intval($row->auth_announce));
		$lists['auth_attachments'] = JHTML::_('select.genericlist', $authOptionList, 'auth_attachments', 'class="inputbox" size="1"', 'value', 'text', intval($row->auth_attachments));

		ViewForum::editForum($row, $lists);	
	}
	
	/**
	 * save the forum
	 */	
	function saveForum($task) {
		global $mainframe;

		// initialize variables
		$db 	=& JFactory::getDBO();
		$post	= JRequest::get('post');
		$row 	=& JTable::getInstance('JoobbForum');

		if (!$row->bind($post)) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		
		// we need to request the text separetly, otherwise html tags will be not saved
		$description = JRequest::getVar('description', '', 'post', 'string', JREQUEST_ALLOWRAW);
		// clean text for xhtml transitional compliance
		$row->description = str_replace('<br>', '<br />', $description);
		
		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		$row->checkin();
		$row->reorder('id_cat = '.$row->id_cat);
		
		switch ($task) {
			case 'joobb_forum_apply':
				$link = 'index.php?option=com_joobb&task=joobb_forum_edit&cid[]='. $row->id .'&hidemainmenu=1';
				break;
			case 'joobb_forum_save':
			default:
				$link = 'index.php?option=com_joobb&task=joobb_forum_view';
				break;
		}

		$msg = JText::sprintf('BB_MSGSUCCESSFULLYSAVED', JText::_('BB_FORUM'), $row->name);
		$mainframe->redirect($link, $msg);
	}
	
	/**
	 * delete the forum
	 */	
	function deleteForum() {
		global $mainframe;

		// initialize variables
		$db			=& JFactory::getDBO();
		$cid		= JRequest::getVar('cid', array(), 'post', 'array');
		$msgType	= '';
		
		JArrayHelper::toInteger( $cid );

		if (count($cid)) {
			
			// how many forums are there to delete?
			if (count($cid) == 1) {
				$row =& JTable::getInstance('JoobbForum'); $row->load($cid[0]);
				$msg = JText::sprintf('BB_MSGSUCCESSFULLYDELETED', JText::_('BB_FORUM'), $row->name);
			} else {
				$msg = JText::sprintf('BB_MSGSUCCESSFULLYDELETED', JText::_('BB_FORUMS'), '');
			}
		
			$query = "DELETE FROM #__joobb_forums"
					. "\n WHERE id = " . implode(' OR id = ', $cid)
					;
			$db->setQuery($query);
			
			if (!$db->query()) {
				$msg = $db->getErrorMsg();
				$msgType = 'error';
			}
		} else {
			$msg = JText::sprintf('BB_MSGNOSELECTION', JText::_('BB_FORUM'), JText::_('BB_DELETE'));
		}

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_forum_view', $msg, $msgType);
	}
	
	/**
	 * moves the order of forum up or down
	 * @param integer increment/decrement
	 */
	function orderForum($direction) {
		global $mainframe;

		// initialize variables
		$db		= & JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );

		if (isset($cid[0])) {
			$row =& JTable::getInstance('JoobbForum');
			$row->load((int) $cid[0]);
			$row->move($direction, 'id_cat = ' . (int) $row->id_cat);
		}
		
		$msg = JText::sprintf('BB_MSGSUCCESSFULLYREORDERED', JText::_('BB_FORUM'), $row->name);
		$mainframe->redirect('index.php?option=com_joobb&task=joobb_forum_view');
	}
	
	/**
	 * save the forum order 
	 */
	function saveForumOrder() {
		global $mainframe;

		// initialize variables
		$db			= & JFactory::getDBO();
		$cid		= JRequest::getVar('cid', array(0), 'post', 'array');
		$order		= JRequest::getVar('order', array (0), 'post', 'array');
		$total		= count($cid);
		$conditions	= array ();

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($order, array(0));

		// instantiate a forum table object
		$row = & JTable::getInstance('JoobbForum');

		// update the ordering for items in the cid array
		for ($i = 0; $i < $total; $i ++) {
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError( 500, $db->getErrorMsg() );
					return false;
				}
				
				// remember to updateOrder this group
				$condition = "id_cat = $row->id_cat";
				$found = false;
				foreach ($conditions as $cond)
					if ($cond[1] == $condition) {
						$found = true;
						break;
					}
				if (!$found)
					$conditions[] = array($row->id, $condition);
			}
		}

		// execute updateOrder for each group
		foreach ($conditions as $cond) {
			$row->load($cond[0]);
			$row->reorder($cond[1]);
		}

		$msg = JText::sprintf('BB_MSGSUCCESSFULLYSAVEDORDER', JText::_('BB_FORUM'));
		$mainframe->redirect('index.php?option=com_joobb&task=joobb_forum_view', $msg);
	}
	
	/**
	 * changes the publish state of a forum
	 * @param integer 0 = unpublishing, 1 = publishing
	 */
	function changeForumPublishState($state = 0) {
		global $mainframe;
		
		// initialize variables
		$db			= & JFactory::getDBO();
		$cid		= JRequest::getVar('cid', array(0), 'post', 'array');
		$msgType	= '';

		JArrayHelper::toInteger($cid);

		if (count($cid)) {
			$msgText = ($state == 1) ? 'BB_MSGSUCCESSFULLYPUBLISHED' : 'BB_MSGSUCCESSFULLYUNPUBLISHED';
			
			// are there one or more rows to publish/unpublish?
			if (count($cid) == 1) {
				$row =& JTable::getInstance('JoobbForum'); $row->load($cid[0]);
				$msg = JText::sprintf($msgText, JText::_('BB_FORUM'), $row->name);
			} else {
				$msg = JText::sprintf($msgText, JText::_('BB_FORUMS'), '');
			}

			$query = "UPDATE #__joobb_forums"
					. "\n SET status = $state"
					. "\n WHERE id = " . implode(' OR id = ', $cid)
					;
			$db->setQuery($query);
	
			if (!$db->query()) {
				$msg = $db->getErrorMsg();
				$msgType = 'error';
			}
		}
		
		$mainframe->redirect('index.php?option=com_joobb&task=joobb_forum_view', $msg, $msgType);
	}
}
?>