<?php
/**
 * @version $Id: iconset.php 447 2009-02-02 20:23:47Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2008 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT.DS.'views'.DS.'iconset.php');

/**
 * Joo!BB Icon Set Controller
 *
 * @package Joo!BB
 */
class ControllerIconSet extends JController
{

	/**
	 * compiles a list of icon sets
	 */
	function showIconSets() {
		global $mainframe;
		
		// initialize variables
		$db			=& JFactory::getDBO();
		
		$context		= 'com_joobb.joobb_iconset_view';
		$limit			= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart		= $mainframe->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');

		// get default button set
		$query = "SELECT d.icon_set"
				. "\n FROM #__joobb_designs AS d"
				. "\n WHERE d.default_design = 1"
				;
		$db->setQuery($query);
		$defaultIconSet = $db->loadResult();
		
		// list templates
		jimport('joomla.filesystem.folder');
		$iconSets = JFolder::folders(JOOBB_ICONS);
				
		$rows = array();
		foreach($iconSets as $iconSetFolder) {
			$fileList = JFolder::files(JOOBB_ICONS.DS.$iconSetFolder, '.xml');
			foreach($fileList as $iconSetFile) {
				if(!$data = JoobbHelper::parseXMLFile(JOOBB_ICONS.DS.$iconSetFolder, $iconSetFile, 'iconset')){
					continue;
				} else {
					$data->default_icon_set =($data->file_name == $defaultIconSet);
					$rows[] = $data;
				}
			}
		}
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination(count($rows), $limitstart, $limit);
		$rows = array_slice($rows, $pagination->limitstart, $pagination->limit);

		ViewIconSet::showIconSets($rows, $pagination);	
	}
	
	/**
	 * cancels edit icon set operation
	 */
	function cancelEditIconSet() {
		global $mainframe;
		$link = 'index.php?option=com_joobb&task=joobb_iconset_view';
		$mainframe->redirect($link);
	}
	
	/**
	 * edit the icon set
	 */
	function editIconSet() {
		global $mainframe;
		
		// initialize variables
		$cid 	= JRequest::getVar('cid', array());

		if(!is_array($cid)) {
			$cid = array();
		}

		$joobbIconSet = new JoobbIconSet($cid[0]);
				
		ViewIconSet::editIconSet($joobbIconSet);			
	}
	
	/**
	 * save the icon set
	 */	
	function saveIconSet($task) {
		global $mainframe;

		// initialize variables
		$db =& JFactory::getDBO();

		$post	= JRequest::get('post');

		// ToDo: implement code saving icon set

		switch($task) {
			case 'joobb_iconset_apply':
				$link = 'index.php?option=com_joobb&task=joobb_iconset_edit&cid[]='. $row->id .'&hidemainmenu=1';
				break;

			case 'joobb_iconset_save':
			default:
				$link = 'index.php?option=com_joobb&task=joobb_iconset_view';
				break;
		}

		$msg = JText::sprintf('BB_MSGSUCCESSFULLYSAVED', JText::_('BB_ICONSET'), $row->name);
		$mainframe->redirect($link, $msg);
	}
	
	/**
	 * delete the icon set
	 */	
	function deleteIconSet() {
		global $mainframe;

		// initialize variables
		$db		=& JFactory::getDBO();
		$cid	= JRequest::getVar('cid', array(), 'post', 'array');
		JArrayHelper::toInteger($cid);

		// ToDo: implement code deleting icon set

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_iconset_view', $db->getErrorMsg(), 'error');
	}
	
	/**
	 * set icon set as default
	 */	
	function defaultIconSet() {
		global $mainframe;

		// initialize variables
		$cid = JRequest::getVar('cid', array(), 'post', 'array');

		if(count($cid)) {

			// set the default icon set to true
			JoobbHelper::setDefaultIconSet($cid[0]);
		} else {
			$msg = JText::sprintf('BB_MSGNOSELECTION', JText::_('BB_ICONSET'), JText::_('BB_DEFAULT'));
		}

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_iconset_view', $msg);
	}
	
}
?>