<?php
/**
 * @version $Id: install.php 554 2009-04-05 14:45:50Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2009 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT.DS.'views'.DS.'install.php');

/**
 * Joo!BB Install Controller
 *
 * @package Joo!BB
 */
class ControllerInstall extends JController
{

	/**
	 * shows installation view
	 */
	function showInstall() {
		global $mainframe;
		
		// initialize variables
		$db	=& JFactory::getDBO();
		
		$db->setQuery("SHOW TABLE STATUS LIKE '%joobb%'");
		$rows = $db->loadObjectList();
		
		// parameter list
		$lists = array();
		
		// db installed
		if (count($rows)) {
			$lists['db_installed'] = true;
		} else {
			$lists['db_installed'] = false;
		}
		
		// current installed version
		$lists['version'] = JoocmHelper::getVersion(JOOBB_ADMINBASEPATH.DS.'install.joobb.xml');
		
		// available version
		$lists['available_version'] = JoocmHelper::getAvailableVersion('www.joobb.org', 'http://www.joobb.org/version/joobb_version.txt');
		
		ViewInstall::showInstall($rows, $lists);	
	}

	/**
	 * perform install
	 */
	function performInstall() {
		global $mainframe;
		
		$msg = JText::_('BB_MSGINSTALLDBSUCCESS');
		
		// drop all tables
		if (ControllerInstall::executeSQLFile('uninstall.joobb.sql')) {
		
			// create all tables and fill initial data
			if (!ControllerInstall::executeSQLFile('install.joobb.sql')) {
				$msg = JText::_('BB_MSGINSTALLDBFAILED');
			}
		} else {
			$msg = JText::_('BB_MSGINSTALLDBFAILED');
		}

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_install_view', $msg);
	}
	
	/**
	 * perform update
	 */	
	function performUpdate($task) {
		global $mainframe;
		
		$msg = JText::_('BB_MSGUPDATEDBSUCCESS');

		// create all tables and fill initial data
		if (!ControllerInstall::executeSQLFile('updates'.DS.'update_091.joobb.sql')) {
			$msg = JText::_('BB_MSGUPDATEDBFAILED');
		}
		
		// create all tables and fill initial data
		if (!ControllerInstall::executeSQLFile('updates'.DS.'update_092.joobb.sql')) {
			$msg = JText::_('BB_MSGUPDATEDBFAILED');
		}

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_install_view', $msg);
	}

	/**
	 * execute sql file
	 */	
	function executeSQLFile($sqlFile) {
		global $mainframe;
		
		// create the absolute path of the sql file
		$sqlFile = JOOBB_ADMINBASEPATH.DS.$sqlFile;
		
		// if the sql file doesn't exists then leave
		if (!file_exists($sqlFile)) {
			$mainframe->enqueueMessage($sqlFile, 'error'); return false;
		}
		$buffer = file_get_contents($sqlFile);

		// leave if the buffer is empty
		if (!$buffer) {
			return false;
		}

		// split all queries to an array
		jimport('joomla.installer.helper');
		$queries = JInstallerHelper::splitSql($buffer);
		
		// leave if there are no queries
		if (count($queries) == 0) {
			return false;
		}

		// execute each of the queries
		foreach ($queries as $query) {
			$query = trim($query);
			if ($query != '' && $query{0} != '#') {
				if (!ControllerInstall::executeQuery($query)) {
					return false;
				}
			}
		}
		
		return true;
	}
	
	/**
	 * execute query
	 */	
	function executeQuery($query) {
		global $mainframe;
		
		// initialize variables
		$db	=& JFactory::getDBO();
		
		$db->setQuery($query);
		if (!$db->query()) {
			$mainframe->enqueueMessage($db->getErrorMsg(), 'error'); return false;
		}
		
		return true;
	}
}
?>