<?php
/**
 * @version $Id: rank.php 447 2009-02-02 20:23:47Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2008 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */
 
// no direct access
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT.DS.'views'.DS.'rank.php');

/**
 * Joo!BB Rank Controller
 *
 * @package Joo!BB
 */
class ControllerRank extends JController
{

	/**
	 * compiles a list of rank
	 */
	function showRanks() {
		global $mainframe;
		
		// initialize variables
		$db			=& JFactory::getDBO();
		
		$context			= 'com_joobb.joobb_rank_view';
		$filter_order		= $mainframe->getUserStateFromRequest("$context.filter_order", 'filter_order', 'r.min_posts');
		$filter_order_Dir	= $mainframe->getUserStateFromRequest("$context.filter_order_Dir",	'filter_order_Dir',	'');
		$limit				= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart			= $mainframe->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');
		
		$orderby = "\n ORDER BY $filter_order $filter_order_Dir";
		
		// get the total number of records
		$query = "SELECT COUNT(*)"
				. "\n FROM #__joobb_ranks AS r"
				. $orderby
				;		
		$db->setQuery($query);
		$total = $db->loadResult();
		
		// create the pagination object
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);
												
		$query = "SELECT r.*"
				. "\n FROM #__joobb_ranks AS r"
				. $orderby
				;
		$db->setQuery($query, $pagination->limitstart, $pagination->limit);
		$rows = $db->loadObjectList();
		
		// parameter list
		$lists = array();
		
		// table ordering
		$lists['filter_order'] = $filter_order;
		$lists['filter_order_Dir']	= $filter_order_Dir;
			
		ViewRank::showRanks($rows, $pagination, $lists);	
	}
	
	/**
	 * cancels edit rank operation
	 */
	function cancelEditRank() {
		global $mainframe;
		
		// check in category so other can edit it
		$row =& JTable::getInstance('JoobbRank');
		$row->bind(JRequest::get('post'));
		$row->checkin();
	
		$link = 'index.php?option=com_joobb&task=joobb_rank_view';
		$mainframe->redirect($link);
	}
	
	/**
	 * edit the rank
	 */
	function editRank() {
		global $mainframe;
		
		// initialize variables
		$db		=& JFactory::getDBO();
		$user	=& JFactory::getUser();
		$cid 	= JRequest::getVar('cid', array(0));
		
		if (!is_array($cid)) {
			$cid = array(0);
		}
		
		$row =& JTable::getInstance('JoobbRank');
		$row->load($cid[0]);

		// is someone else editing this rank?
		if (JTable::isCheckedOut($user->get('id'), $row->checked_out)) {
			$link = 'index.php?option=com_joobb&task=joobb_rank_view';
			$editingUser =& JFactory::getUser($row->checked_out);
			$msg = JText::sprintf('BB_MSGBEINGEDITTED', JText::_('BB_RANK'), $row->name, $editingUser->name);
			$mainframe->redirect($link, $msg);
		}
		
		// parameter list
		$lists = array();

		// build the html radio buttons for state
		$lists['published'] = JHTML::_('select.booleanlist', 'published', '', $row->published);		
				
		ViewRank::editRank($row, $lists);			
	}
	
	/**
	 * save the rank
	 */	
	function saveRank($task) {
		global $mainframe;

		// initialize variables
		$db =& JFactory::getDBO();
		$post	= JRequest::get('post');
		$row =& JTable::getInstance('JoobbRank');

		if (!$row->bind($post)) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		$row->checkin();

		switch ($task) {
			case 'joobb_rank_apply':
				$link = 'index.php?option=com_joobb&task=joobb_rank_edit&cid[]='. $row->id .'&hidemainmenu=1';
				break;
			case 'joobb_rank_save':
			default:
				$link = 'index.php?option=com_joobb&task=joobb_rank_view';
				break;
		}

		$msg = JText::sprintf('BB_MSGSUCCESSFULLYSAVED', JText::_('BB_RANK'), $row->name);
		$mainframe->redirect($link, $msg);
	}
	
	/**
	 * delete the rank
	 */	
	function deleteRank() {
		global $mainframe;

		// initialize variables
		$db			=& JFactory::getDBO();
		$cid		= JRequest::getVar('cid', array(), 'post', 'array');
		$msgType	= '';
		
		JArrayHelper::toInteger($cid);
		
		if (count($cid)) {
			
			// how many categories are there to delete?
			if (count($cid) == 1) {
				$row =& JTable::getInstance('JoobbRank'); $row->load($cid[0]);
				$msg = JText::sprintf('BB_MSGSUCCESSFULLYDELETED', JText::_('BB_RANK'), $row->name);
			} else {
				$msg = JText::sprintf('BB_MSGSUCCESSFULLYDELETED', JText::_('BB_RANKS'), '');
			}
		
			$query = "DELETE FROM #__joobb_ranks"
					. "\n WHERE id = " . implode(' OR id = ', $cid)
					;
			$db->setQuery($query);
			
			if (!$db->query()) {
				$msg = $db->getErrorMsg();
				$msgType = 'error';
			}
		} else {
			$msg = JText::sprintf('BB_MSGNOSELECTION', JText::_('BB_RANK'), JText::_('BB_DELETE'));
		}

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_rank_view', $msg, $msgType);
	}
	
	/**
	 * Changes the publish state of a rank
	 * @param integer 0 = unpublishing, 1 = publishing
	 */
	function changeRankPublishState($state = 0) {
		global $mainframe;
		
		// initialize variables
		$db			= & JFactory::getDBO();
		$cid		= JRequest::getVar('cid', array(0), 'post', 'array');
		$msgType	= '';
		
		JArrayHelper::toInteger($cid);
		
		if (count($cid)) {
			$msgText = ($state == 1) ? 'BB_MSGSUCCESSFULLYPUBLISHED' : 'BB_MSGSUCCESSFULLYUNPUBLISHED';
			
			// are there one or more rows to publish/unpublish?
			if (count($cid) == 1) {
				$row =& JTable::getInstance('JoobbCategory'); $row->load($cid[0]);
				$msg = JText::sprintf($msgText, JText::_('BB_CATEGORY'), $row->name);
			} else {
				$msg = JText::sprintf($msgText, JText::_('BB_CATEGORIES'), '');
			}
			
			$query = "UPDATE #__joobb_ranks"
					. "\n SET published = $state"
					. "\n WHERE id = " . implode(' OR id = ', $cid)
					;
			$db->setQuery($query);
	
			if (!$db->query()) {
				$msg = $db->getErrorMsg();
				$msgType = 'error';
			}
		}

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_rank_view', $msg, $msgType);
	}
			
}
?>