<?php
/**
 * @version $Id: sitemap.php 568 2009-04-19 11:11:18Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2009 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */
 
// no direct access
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT.DS.'views'.DS.'sitemap.php');

/**
 * Joo!BB Sitemap Controller
 *
 * @package Joo!BB
 */
class ControllerSitemap extends JController
{

	/**
	 * shows user synchronization
	 */
	function showSitemap() {
		global $mainframe;
		
		// initialize variables
		$db				=& JFactory::getDBO();
		$joobbConfig	=& JoobbConfig::getInstance();
		
		// parameter list
		$lists = array();
		
		$priority = array();
		$priority[] = JHTML::_('select.option', 'none', JText::_('BB_NONE'));
		$priority[] = JHTML::_('select.option', 'autodetect', JText::_('BB_AUTODETECT'));
		$lists['priority'] = JHTML::_('select.genericlist',  $priority, 'priority', 'class="inputbox" size="1"', 'value', 'text', 'autodetect');

		$changeFreq = array();
		$changeFreq[] = JHTML::_('select.option', 'none', JText::_('BB_NONE'));
		$changeFreq[] = JHTML::_('select.option', 'autodetect', JText::_('BB_AUTODETECT'));
		$changeFreq[] = JHTML::_('select.option', 'always', JText::_('BB_ALWAYS'));
		$changeFreq[] = JHTML::_('select.option', 'hourly', JText::_('BB_HOURLY'));
		$changeFreq[] = JHTML::_('select.option', 'daily', JText::_('BB_DAILY'));
		$changeFreq[] = JHTML::_('select.option', 'weekly', JText::_('BB_WEEKLY'));
		$changeFreq[] = JHTML::_('select.option', 'monthly', JText::_('BB_MONTHLY'));
		$changeFreq[] = JHTML::_('select.option', 'yearly', JText::_('BB_YEARLY'));
		$changeFreq[] = JHTML::_('select.option', 'never', JText::_('BB_NEVER'));

		$lists['changefreq'] = JHTML::_('select.genericlist',  $changeFreq, 'changefreq', 'class="inputbox" size="1"', 'value', 'text', 'autodetect');

		ViewSitemap::showSitemap($lists);	
	}
	
	/**
	 * perform sitemap
	 */	
	function performSitemap() {
		global $mainframe;
		
		$fileName = JRequest::getVar('filename', '');
		$priority = JRequest::getVar('priority', '');
		$changeFreq = JRequest::getVar('changefreq', '');
		$limit = JRequest::getVar('limit', 0, '', 'int');
		
		$joobbSitemap =& JoobbSitemap::getInstance();
		
		if ($joobbSitemap->createSitemap($fileName, $priority, $changeFreq, $limit)) {
			$msg = JText::_('BB_MSGSITEMAPCREATESUCCESS');
		} else {
			$msg = JText::_('BB_MSGSITEMAPCREATEFAILED');
		}

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_sitemap_view', $msg);
	}
}
?>