<?php
/**
 * @version $Id: style.php 505 2009-02-22 13:38:53Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2008 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once( JPATH_COMPONENT.DS.'views'.DS.'style.php');

/**
 * Joo!BB Style Controller
 *
 * @package Joo!BB
 */
class ControllerStyle extends JController
{

	/**
	 * compiles a list of styles
	 */
	function showStyles() {
		global $mainframe;
		
		// initialize variables
		$db			=& JFactory::getDBO();
		
		$context		= 'com_joobb.joobb_template_view';
		$limit			= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart		= $mainframe->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');

		// get default style
		$query = "SELECT d.style"
				. "\n FROM #__joobb_designs AS d"
				. "\n WHERE default_design = 1"
				;
		$db->setQuery($query);
		foreach ($db->loadObject() as $defaultstyle);
		
		// list styles
		jimport('joomla.filesystem.folder');
		$styleList = JFolder::folders(JOOBB_STYLES);
				
		$rows = array();
		foreach ($styleList as $styleFolder) {
			$fileList = JFolder::files(JOOBB_STYLES.DS.$styleFolder, '.xml');
			foreach ($fileList as $styleFile) {
				if(!$data = JoobbHelper::parseXMLFile(JOOBB_STYLES.DS.$styleFolder, $styleFile, 'style')) {
					continue;
				} else {
					$data->default_style = ($data->file_name == $defaultstyle);
					$data->folder_name = $styleFolder;
					$rows[] = $data;
				}
			}
		}
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination(count($rows), $limitstart, $limit);
		$rows = array_slice($rows, $pagination->limitstart, $pagination->limit);
		
		ViewStyle::showStyles($rows, $pagination);	
	}
	
	/**
	 * cancels edit style operation
	 */
	function cancelEditStyle() {
		global $mainframe;
		$link = 'index.php?option=com_joobb&task=joobb_style_view';
		$mainframe->redirect($link);
	}
	
	/**
	 * edit the style
	 */
	function editStyle() {
		global $mainframe;
		
		// initialize variables
		$db		=& JFactory::getDBO();
		$cid 	= JRequest::getVar('cid', array(0));
		
		if (!is_array($cid)) {
			$cid = array(0);
		}	

		if(!$data = JoobbHelper::parseXMLFile(JOOBB_STYLES.DS.basename($cid[0], ".xml"), $cid[0], 'style')) {
			$link = 'index.php?option=com_joobb&task=joobb_style_view';
			$msg  = sprintf(JText::_('BB_MSGFILENOTFOUND'), $cid[0]);
			$mainframe->redirect($link, $msg);
		} else {
			$row = $data;
		}
		
		$lists = array();
		
		// get default style
		$query = "SELECT d.style"
				. "\n FROM #__joobb_designs AS d"
				. "\n WHERE default_design = 1"
				;
		$db->setQuery($query);
		$defaultstyle = $db->loadResult();
		
		// build the html radio buttons for default style
		$lists['defaultstyle'] = JHTML::_('select.booleanlist', 'defaultstyle', '', ($row->file_name == $defaultstyle));			
				
		ViewStyle::editStyle($row, $lists);			
	}
	
	/**
	 * save the style
	 */	
	function saveStyle($task) {
		global $mainframe;
		
		// initialize variables
		$file_name	= JRequest::getVar('file_name');
		
		if(!$style = JoobbHelper::parseXMLFile(JOOBB_STYLES.DS.basename($file_name, ".xml"), $file_name, 'style')) {
			$link = 'index.php?option=com_joobb&task=joobb_style_view';
			$msg  = sprintf(JText::_('BB_MSGFILENOTFOUND'), $file_name);
			$mainframe->redirect($link, $msg);
		}
		
		// set the default style		
		if (JRequest::getVar('defaultstyle')) {
			JoobbHelper::setDefaultStyle($style->file_name);			
		}
								
		switch ($task) {
			case 'joobb_style_apply':
				$link = 'index.php?option=com_joobb&task=joobb_style_edit&cid[]='. $style->file_name .'&hidemainmenu=1';
				break;

			case 'joobb_style_save':
			default:
				$link = 'index.php?option=com_joobb&task=joobb_style_view';
				break;
		}
		
		$msg = JText::sprintf('BB_MSGSUCCESSFULLYSAVED', JText::_('BB_STYLE'), $style->name);
		$mainframe->redirect($link, $msg);
	}
	
	/**
	 * delete the style
	 */	
	function deleteStyle() {
		global $mainframe;
		
		// ToDo: Source for delete style

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_style_view');
	}
	
	/**
	 * set style as default
	 */	
	function defaultStyle() {
		global $mainframe;

		// initialize variables
		$cid	= JRequest::getVar('cid', array(), 'post', 'array');

		if (count($cid)) {

			// set the selected style to default
			JoobbHelper::setDefaultStyle($cid[0]);	
		} else {
			$msg = JText::sprintf('BB_MSGNOSELECTION', JText::_('BB_STYLE'), JText::_('BB_DEFAULT'));
		}

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_style_view');
	}		
}
?>