<?php
/**
 * @version $Id: template.php 505 2009-02-22 13:38:53Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2008 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */
 
// no direct access
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT.DS.'views'.DS.'template.php');

/**
 * Joo!BB Template Controller
 *
 * @package Joo!BB
 */
class ControllerTemplate extends JController
{

	/**
	 * compiles a list of templates
	 */
	function showTemplates() {
		global $mainframe;
		
		// initialize variables
		$db			=& JFactory::getDBO();
		$context		= 'com_joobb.joobb_template_view';
		$limit			= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart		= $mainframe->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');

		// get default template
		$query = "SELECT d.template"
				. "\n FROM #__joobb_designs AS d"
				. "\n WHERE default_design = 1"
				;
		$db->setQuery($query);
		$defaulttemplate = $db->loadResult();
		
		// list templates
		jimport('joomla.filesystem.folder');
		$templatesList 	= JFolder::folders(JOOBB_TEMPLATES);
				
		$rows = array();
		foreach ($templatesList as $templateFolder) {
			$fileList = JFolder::files(JOOBB_TEMPLATES.DS.$templateFolder, '.xml');
			foreach ($fileList as $templateFile) {
				if(!$data = JoobbHelper::parseXMLFile(JOOBB_TEMPLATES.DS.$templateFolder, $templateFile, 'template')){
					continue;
				} else {
					$data->default_template = ($data->file_name == $defaulttemplate);
					$rows[]  = $data;
				}
			}
		}
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination(count($rows), $limitstart, $limit);
		$rows = array_slice($rows, $pagination->limitstart, $pagination->limit);
		
		ViewTemplate::showTemplates($rows, $pagination);	
	}
	
	/**
	 * cancels edit template operation
	 */
	function cancelEditTemplate() {
		global $mainframe;
		$link = 'index.php?option=com_joobb&task=joobb_template_view';
		$mainframe->redirect($link);
	}
	
	/**
	 * edit the template
	 */
	function editTemplate() {
		global $mainframe;
		
		// initialize variables
		$db		=& JFactory::getDBO();
		$cid 	= JRequest::getVar('cid', array(0));
		
		if (!is_array($cid)) {
			$cid = array(0);
		}	

		if(!$data = JoobbHelper::parseXMLFile(JOOBB_TEMPLATES.DS.basename($cid[0], ".xml"), $cid[0], 'template')) {
			$link = 'index.php?option=com_joobb&task=joobb_template_view';
			$msg  = sprintf(JText::_('BB_MSGFILENOTFOUND'), $cid[0]);
			$mainframe->redirect($link, $msg);
		} else {
			$row = $data;
		}
		
		$lists = array();
		
		// get default template
		$query = "SELECT d.template"
				. "\n FROM #__joobb_designs AS d"
				. "\n WHERE default_design = 1"
				;
		$db->setQuery($query);
		$defaulttemplate = $db->loadResult();
		
		// build the html radio buttons for default template
		$lists['defaulttemplate'] = JHTML::_('select.booleanlist', 'defaulttemplate', '', ($row->file_name == $defaulttemplate));			
			
		ViewTemplate::editTemplate($row, $lists);			
	}
	
	/**
	 * save the template
	 */	
	function saveTemplate($task) {
		global $mainframe;
		
		// initialize variables
		$file_name	= JRequest::getVar('file_name');
		
		if(!$template = JoobbHelper::parseXMLFile(JOOBB_TEMPLATES.DS.basename($file_name, ".xml"), $file_name, 'template')) {
			$link = 'index.php?option=com_joobb&task=joobb_template_view';
			$msg  = sprintf(JText::_('BB_MSGFILENOTFOUND'), $file_name);
			$mainframe->redirect($link, $msg.'test'.$file_name);
		}
		
		// set the default template		
		if (JRequest::getVar('defaulttemplate')) {
			JoobbHelper::setDefaultTemplate($template->file_name);			
		}
								
		switch ($task) {
			case 'joobb_template_apply':
				$link = 'index.php?option=com_joobb&task=joobb_template_edit&cid[]='. $template->file_name .'&hidemainmenu=1';
				break;

			case 'joobb_template_save':
			default:
				$link = 'index.php?option=com_joobb&task=joobb_template_view';
				break;
		}

		$msg = JText::sprintf('BB_MSGSUCCESSFULLYSAVED', JText::_('BB_TEMPLATE'), $template->name);
		$mainframe->redirect($link, $msg);
	}
	
	/**
	 * delete the template
	 */
	function deleteTemplete() {
		global $mainframe;
		
		// ToDo: Source for delete the template
		
		$mainframe->redirect('index.php?option=com_joobb&task=joobb_template_view');
	}
	
	/**
	 * set template as default
	 */	
	function defaultTemplate() {
		global $mainframe;

		// initialize variables
		$cid	= JRequest::getVar('cid', array(), 'post', 'array');

		if (count($cid)) {

			// set the selected template to default
			JoobbHelper::setDefaultTemplate($cid[0]);	
		}

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_template_view');
	}
		
}
?>