<?php
/**
 * @version $Id: usersync.php 519 2009-03-02 20:53:34Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2009 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */
 
// no direct access
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT.DS.'views'.DS.'usersync.php');

/**
 * Joo!BB User Synchronization Controller
 *
 * @package Joo!BB
 */
class ControllerUserSync extends JController
{

	/**
	 * shows user synchronization
	 */
	function showUserSync() {
		global $mainframe;
		
		// initialize variables
		$db				=& JFactory::getDBO();
		$joobbConfig	=& JoobbConfig::getInstance();
		
		// parameter list
		$lists = array();
		
		$joomlaGroup = array();
		$joomlaGroup[] = JHTML::_('select.option', 0, JText::_('BB_SELECTJOOMLAGROUP'));
		$joomlaGroup[] = JHTML::_('select.option', 18, JText::_('BB_REGISTERED'));
		$joomlaGroup[] = JHTML::_('select.option', 19, JText::_('BB_AUTHOR'));
		$joomlaGroup[] = JHTML::_('select.option', 20, JText::_('BB_EDITOR'));
		$joomlaGroup[] = JHTML::_('select.option', 21, JText::_('BB_PUBLISHER'));
		$joomlaGroup[] = JHTML::_('select.option', 23, JText::_('BB_MANAGER'));
		$joomlaGroup[] = JHTML::_('select.option', 24, JText::_('BB_ADMINISTRATOR'));
		$joomlaGroup[] = JHTML::_('select.option', 25, JText::_('BB_SUPERADMINISTRATOR'));

		$lists['joomlagroup'] = JHTML::_('select.genericlist',  $joomlaGroup, 'joomlagroup', 'class="inputbox" size="1"', 'value', 'text', 0);
		
		// build the html radio buttons for enable bbcode
		$lists['enable_bbcode'] = JHTML::_('select.booleanlist', 'enable_bbcode', '', $joobbConfig->getUserSettingsDefaults('enable_bbcode'));
		// build the html radio buttons for enable smilies
		$lists['enable_emotions'] = JHTML::_('select.booleanlist', 'enable_emotions', '', $joobbConfig->getUserSettingsDefaults('enable_emotions'));

		$joobbAuth =& JoobbAuth::getInstance();
		$lists['roles'] = JHTML::_('select.genericlist', $joobbAuth->getUserRoleOptionList(), 'role', 'class="inputbox" size="1"', 'value', 'text', $joobbConfig->getUserSettingsDefaults('role'));
				
		ViewUserSync::showUserSync($lists);	
	}
	
	/**
	 * perform user synchronization
	 */	
	function performUserSync() {
		global $mainframe;
	
		$joomlaGroup	= JRequest::getVar('joomlagroup', 0, '', 'int');

		if (!$joomlaGroup) {
			$mainframe->redirect('index.php?option=com_joobb&task=joobb_usersync_view', JText::_('BB_MSGSELECTJOOMLAGROUP')); return false;
		}
		
		// initialize some variables
		$db	= & JFactory::getDBO();

		// get all existing joomla users
		$query = "SELECT u.id"
				. "\n FROM #__users AS u"
				. "\n WHERE u.gid = $joomlaGroup"
				;
		$db->setQuery($query);
		$joomlaUsers = $db->loadObjectList();	

		if (count($joomlaUsers)) {
		
			$role			= JRequest::getVar('role', 0, '', 'int');
			$enableBBCode	= JRequest::getVar('enable_bbcode', 1, '', 'int');
			$enableEmotions	= JRequest::getVar('enable_emotions', 1, '', 'int');
		
			foreach ($joomlaUsers as $joomlaUser) {

				// check if the user already exists
				$query = "SELECT ju.id"
						. "\n FROM #__joobb_users AS ju"
						. "\n WHERE ju.id = ". $joomlaUser->id
						;
				$db->setQuery($query);
				$userExists = $db->loadResult();

				if (!$userExists) {		
					$query = "INSERT INTO #__joobb_users (id, role, enable_bbcode, enable_emotions) VALUES"
							. "\n (".$joomlaUser->id.",$role,$enableBBCode,$enableEmotions)"
							;
					$db->setQuery($query);
					
					if (!$db->query()) {
						$mainframe->redirect('index.php?option=com_joobb&task=joocm_usersync_view', $db->getErrorMsg(), 'error'); return false;
					}
				}			
			}
			$msg = JText::sprintf('BB_MSGSUCCESSFULLYSYNCHRONIZED', JText::_('BB_USERS'));
		} else {
			$msg = JText::_('BB_MSGNOUSERSTOSYNCHRONIZE');
		}

		$mainframe->redirect('index.php?option=com_joobb&task=joobb_usersync_view', $msg);
	}
}
?>