<?php
/**
 * @version $Id: joobb.php 15 2009-09-13 08:59:39Z joomweb $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2009 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

/**
 * Joo!BB Helper
 *
 * @package Joo!BB
 */
class JoobbHelper
{

	/**
	 * get a joobb user object
	 */
	function &getJoobbUser() {
	
		// if there is a userid in the session, load the application user object with the logged in user.
		$user = &JFactory::getUser();
		
		$userId = 0;
		if (is_object($user)) {
			$userId = (int)$user->get('id');
		}
		
		$instance =& JoobbUser::getInstance($userId);
		return $instance;
	}
	
	/**
	 * check if a joobb user is logged in
	 */	
	function isUserLoggedIn() {
		$joobbUser =& JoobbHelper::getJoobbUser();
	    return ($joobbUser->get('id')) ? true : false;
	}
	
	/**
	 * get a JoobbEditor object
	 *
	 * @access public
	 * @return object JoobbEditor object
	 */
	function &getEditor() {
		jimport('joomla.html.editor');

		// get the editor configuration setting
		$joobbConfig =& JoobbConfig::getInstance();
		$editor = $joobbConfig->getEditor();

		$instance =& JoobbEditor::getInstance($editor);

		return $instance;
	}

	function getStyleSheet($live = false) {
		$joobbConfig =& JoobbConfig::getInstance();
		
		// get style name
		$style = basename($joobbConfig->getStyleFile(), ".xml");
			
		if ($live) {
			$ds = DL; $styleSheetPath = JOOBB_STYLES_LIVE;
		} else {
			$ds = DS; $styleSheetPath = JOOBB_STYLES;
		}
		
		return $styleSheetPath.$ds.$style.$ds.$style.'.css';
	}
		
	function getStyleSheetPath($live = false) {
		$joobbConfig =& JoobbConfig::getInstance();

		if ($live) {
			$ds = DL; $styleSheetPath = JOOBB_STYLES_LIVE;
		} else {
			$ds = DS; $styleSheetPath = JOOBB_STYLES;
		}
				
		return $styleSheetPath.$ds.basename($joobbConfig->getStyleFile(), ".xml");
	}
	
	function getTemplatePath($live = false) {
		$joobbConfig =& JoobbConfig::getInstance();

		if ($live) {
			$ds = DL; $templatePath = JOOBB_TEMPLATES_LIVE;
		} else {
			$ds = DS; $templatePath = JOOBB_TEMPLATES;
		}

		return $templatePath.$ds.basename($joobbConfig->getTemplateFile(), ".xml");
	}
	
	function formatDate($date, $timeformat, $timeZoneOffset=0) {
		jimport('joomla.utilities.date');

		$instance = new JDate($date);
		$instance->setOffset($timeZoneOffset);
		
		return $instance->toFormat($timeformat);
	}

	function getLocale() {
		static $joobbLocale;

		if (!isset($joobbLocale)) {
			$params = JComponentHelper::getParams('com_languages');
			$joobbLocale = $params->get('site', 'en-GB');
		}

		return $joobbLocale;
	}
	
	function getLastPostIdTopic($topicId) {
	
		// initialize variables
		$db		=& JFactory::getDBO();
		
		$query = "SELECT MAX(p.id)"
				. "\n FROM #__joobb_posts AS p"
				. "\n WHERE p.id_topic = $topicId"
				. "\n GROUP BY p.id_topic"
				;
		$db->setQuery($query);
		
		return $db->loadResult();
		
	}
	
	function getLastPostIdForum($forumId) {
	
		// initialize variables
		$db		=& JFactory::getDBO();
		
		$query = "SELECT MAX(p.id)"
				. "\n FROM #__joobb_posts AS p"
				. "\n WHERE p.id_forum = $forumId"
				. "\n GROUP BY p.id_forum"
				;
		$db->setQuery($query);
		
		return $db->loadResult();
		
	}
	
	function getLastPostTimeByIP($ip) {
	
		// initialize variables
		$db		=& JFactory::getDBO();
		
		$query = "SELECT MAX(p.date_post)"
				. "\n FROM #__joobb_posts AS p"
				. "\n WHERE p.ip_poster = '$ip'"
				. "\n GROUP BY p.ip_poster"
				;
		$db->setQuery($query);
		
		return $db->loadResult();
		
	}
	
	function setDefaultConfig($id_config) {
	
		// initialize variables
		$db		=& JFactory::getDBO();
		
		// set selected config to true
		$query = "UPDATE #__joobb_configs"
				. "\n SET default_config = 1"
				. "\n WHERE id = ". $id_config
				;
		$db->setQuery($query);
		
		if ($db->query()) {
				
			// set all other configs to false
			$query = "UPDATE #__joobb_configs"
					. "\n SET default_config = 0"
					. "\n WHERE id <> ". $id_config
					;
			$db->setQuery($query);		

			if (!$db->query()) {
				JError::raiseError(1001, $db->getErrorMsg());
			}						
		} else {
			JError::raiseError(1001, $db->getErrorMsg());
		}				
	}

	function setDefaultDesign($id_design) {
	
		// initialize variables
		$db		=& JFactory::getDBO();
			
		// set default design for to true
		$query = "UPDATE #__joobb_designs"
				. "\n SET default_design = 1"
				. "\n WHERE id = ". $id_design
				;
		$db->setQuery($query);

		if ($db->query()) {
			
			// set all other designs to false
			$query = "UPDATE #__joobb_designs"
					. "\n SET default_design = 0"
					. "\n WHERE id <> ". $id_design
					;
			$db->setQuery($query);
			
			if (!$db->query()) {
				JError::raiseError(1001, $db->getErrorMsg());
			}
		} else {
			JError::raiseError(1001, $db->getErrorMsg());
		}		
	}

	function setDefaultTemplate($templateFile) {
	
		// initialize variables
		$db		=& JFactory::getDBO();
			
		// set default design for to true
		$query = "UPDATE #__joobb_designs"
				. "\n SET template = '$templateFile'"
				. "\n WHERE default_design = 1"
				;
		$db->setQuery($query);

		if (!$db->query()) {
			JError::raiseError(1001, $db->getErrorMsg());
		}		
	}

	function setDefaultStyle($styleFile) {
	
		// initialize variables
		$db		=& JFactory::getDBO();
			
		// set default style for to true
		$query = "UPDATE #__joobb_designs"
				. "\n SET style = '$styleFile'"
				. "\n WHERE default_design = 1"
				;
		$db->setQuery($query);

		if (!$db->query()) {
			JError::raiseError(1001, $db->getErrorMsg());
		}		
	}

	function setDefaultEmotionSet($emotionSetFile) {
	
		// initialize variables
		$db		=& JFactory::getDBO();
			
		// set default emotion set to true
		$query = "UPDATE #__joobb_designs"
				. "\n SET emotion_set = '$emotionSetFile'"
				. "\n WHERE default_design = 1"
				;
		$db->setQuery($query);

		if (!$db->query()) {
			JError::raiseError(1001, $db->getErrorMsg());
		}		
	}

	function setDefaultButtonSet($buttonSetFile) {
	
		// initialize variables
		$db		=& JFactory::getDBO();
			
		// set default button set to true
		$query = "UPDATE #__joobb_designs"
				. "\n SET button_set = '$buttonSetFile'"
				. "\n WHERE default_design = 1"
				;
		$db->setQuery($query);

		if (!$db->query()) {
			JError::raiseError(1001, $db->getErrorMsg());
		}		
	}

	function setDefaultIconSet($iconSetFile) {
	
		// initialize variables
		$db		=& JFactory::getDBO();
			
		// set default icon set to true
		$query = "UPDATE #__joobb_designs"
				. "\n SET icon_set = '$iconSetFile'"
				. "\n WHERE default_design = 1"
				;
		$db->setQuery($query);

		if (!$db->query()) {
			JError::raiseError(1001, $db->getErrorMsg());
		}		
	}
		
	function parseXMLFile($folderName, $fileName, $type) {

		$xml = JApplicationHelper::parseXMLInstallFile($folderName.DS.$fileName);

		if ($xml['type'] != $type) {
			return false;
		}

		$data = new StdClass();
		
		foreach($xml as $key => $value) {
			$data->$key = $value;
		}
		
		$data->directory = $folderName;
		$data->checked_out = 0;
		$data->file_name = $fileName;

		return $data;	
	}

	function &getPostPreview(&$post) {
		global $mainframe, $Itemid;
		
		// initialize variables		
		$joobbConfig	=& JoobbConfig::getInstance();
		$joobbUser		=& JoobbHelper::getJoobbUser();
		$joobbIconSet 	=& JoobbIconSet::getInstance($joobbConfig->getIconSetFile());
				
		// duplicate the object so we do not manipulate original data
		$postPreview = clone $post;
		
		$joobbEngine =& JoobbEngine::getInstance();
		$joobbEngine->convertToHtml($postPreview);
			
		$postPreview->author = $joobbUser->get('name');
		$postPreview->postDate = JoocmHelper::Date($post->date_post);
		
		// post icon
		$postPreview->postIcon = $joobbIconSet->iconByFunction[$postPreview->icon_function];
	
		return $postPreview;
	}
	
	function getForumURL($forumId) {
		global $mainframe, $Itemid;
			
		// initialize variables		
		$forum =& JTable::getInstance('JoobbForum');
		$forum->load($forumId);
		
		$vokale = array(" ", "!", "?");
		
		$forumURL = $forum->id .'-'. ereg_replace("[^A-Za-z0-9]", "", $forum->name);

		return $forumURL;
	}
	
	function getTopicURL($topicId) {
		global $mainframe, $Itemid;
			
		// initialize variables
		if ($topicId) {		
			$topic =& JTable::getInstance('JoobbTopic');
			$topic->load($topicId);
			$firstPost =& JTable::getInstance('JoobbPost');
			$firstPost->load($topic->id_first_post);
			
			$topicURL = $topic->id .'-'. ereg_replace("[^A-Za-z0-9]", "", $firstPost->subject);
		} else {
			$topicURL = $topicId .'-new';
		}
		
		return $topicURL;
	}
		
	/**
	 * get limit start
	 *
	 * @return integer
	 */
	function getLimitStart($topicId, $postId) {
		$db				=& JFactory::getDBO();
		$joobbConfig	=& JoobbConfig::getInstance();
		
		// initialize variables
		$postsPerPage	= $joobbConfig->getBoardSettings('posts_per_page');
		$result			= '';

		$query = "SELECT p.id"
				. "\n FROM #__joobb_posts AS p"
				. "\n INNER JOIN #__joobb_topics AS t ON t.id = p.id_topic"
				. "\n INNER JOIN #__joobb_forums AS f ON f.id = t.id_forum"
				. "\n WHERE p.id_topic = $topicId"
				. "\n ORDER BY p.id"
				;
		$db->setQuery($query);
		$rows = $db->loadResultArray();
		if (count($rows)) {
			$index = array_search($postId, $rows);
			if ($index) {
				$limitStart = (int)($index / $postsPerPage) * $postsPerPage;
				if ($limitStart > 0) {
					$result = '?start='.$limitStart;
				}
			}
		}
				
		return $result;
	}
}
?>