<?php
/**
 * @version $Id: joobbbuttonset.php 449 2009-02-03 10:10:13Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2008 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

/**
 * Joo!BB Button Set
 *
 * @package Joo!BB
 */
class JoobbButtonSet
{
	/**
	 * The manifest XML object
	 * @var object
	 */
	var $_xml = null;
	
	var $name;
	
	var $xmlFile;
	
	var $buttons;
	
	var $buttonByFunction;
	
	function JoobbButtonSet($xmlFile) {
		
		// initialize variables
		$messageQueue	=& JoobbMessageQueue::getInstance();
		
		$this->name = basename($xmlFile, ".xml");
		$this->xmlFile = $xmlFile;
		$this->buttons = array();
		
		if (file_exists(JOOBB_BUTTONS.DS.$this->name.DS.$xmlFile)) {
			$this->_xml =& JFactory::getXMLParser('Simple');
			$this->_xml->loadFile(JOOBB_BUTTONS.DS.basename($xmlFile, ".xml").DS.$xmlFile);
	
			$root = & $this->_xml->document;
			$buttonSet = $root->getElementByPath('buttonset');
			
			if ($buttonSet) {
				
				// load language file
				if ($buttonSet->attributes('translateable')) {
					$this->loadLanguage($xmlFile);
				}

				$elements = $buttonSet->children();

				foreach ($elements as $element) {
					$button = new StdClass();
					$button->fileName = JOOBB_BUTTONS_LIVE.DL.$this->name.DL.JoobbHelper::getLocale().DL.$element->attributes('filename');
					$button->function = $element->attributes('function');
					$button->title = JText::_($element->attributes('title'));
					$this->buttons[] = $button;
					$this->buttonByFunction[$button->function] = $button;
				}
			} else {
				$messageQueue->addMessage(JText::sprintf('BB_MSGXMLPARSINGERROR', JText::_('BB_BUTTONSET'), JOOBB_BUTTONS.DS.$this->name.DS.$xmlFile));
			}
		} else {
			$messageQueue->addMessage(JText::sprintf('BB_MSGRESSOURCENOTFOUND', JText::_('BB_BUTTONSET'), JOOBB_BUTTONS.DS.$this->name.DS.$xmlFile));
		}
	}
	
	/**
	 * get instance
	 *
	 * @access	public
	 * @return	object
	 */
	function &getInstance() {
	
		static $joobbButtonSet;

		if (!is_object($joobbButtonSet)) {
			$joobbConfig	=& JoobbConfig::getInstance();
			$joobbButtonSet = new JoobbButtonSet($joobbConfig->getButtonSetFile());
		}

		return $joobbButtonSet;
	}
	
	/**
	 * load language
	 *
	 * @access 	public
	 */

	function loadLanguage($xmlFile) {
	
		// initialize variables
		$messageQueue	=& JoobbMessageQueue::getInstance();
	
		// load language file for buttons
		$langFile = JOOBB_BUTTONS.DS.$this->name.DS.JoobbHelper::getLocale().DS.$this->name.'.ini';
		
		if (!is_file($langFile)) {
			$langFile = JOOBB_BUTTONS.DS.$this->name.DS.'en-GB'.DS.$this->name.'.ini';	
		}	
				
		if (is_file($langFile)) {
			$lang =& JFactory::getLanguage();
			$lang->_load($langFile); // sorry for calling private function, but there is no other solution at the moment!
		} else {
			$messageQueue->addMessage(JText::sprintf('BB_MSGNOLANGUAGEFILE', JText::_('BB_BUTTONSET')));
		}
	}

}
?>