<?php
/**
 * @version $Id: config.php 576 2009-07-26 19:08:45Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2009 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */
 
// no direct access
defined('_JEXEC') or die('Restricted access');

/**
 * Joo!BB Config View
 *
 * @package Joo!BB
 */
class ViewConfig {

	/**
	 * show configs
	 */	
	function showConfigs(&$rows, $pageNav, &$lists) {
		global $mainframe;
		
		// initialize variables
		$user	=& JFactory::getUser();
				
		$document =& JFactory::getDocument();
		$document->addStyleSheet(JOOBB_ADMINCSS_LIVE.DL.'icon.css');
		
		$task	= JRequest::getVar('task'); ?>
		<div id="submenu-box">
			<div class="t"><div class="t"><div class="t"></div></div></div>			
			<div class="m">
				<ul id="submenu"><li>
					<?php $class = ($task == 'joobb_config_view') ? 'class="active"' : ''; ?>
					<a <?php echo $class; ?> href="index.php?option=com_joobb&task=joobb_config_view"><?php echo JText::_('BB_CONFIG'); ?></a>
				</li></ul>
				<div class="clr"></div>
			</div>
			<div class="b"><div class="b"><div class="b"></div></div></div>
		</div>	
		<form action="index.php?option=com_joobb" method="post" name="adminForm">
			<table class="adminlist" cellspacing="1">
			<thead><tr>
				<th nowrap="nowrap" width="5">
					<?php echo JText::_('Num'); ?>
				</th>
				<th nowrap="nowrap" width="5">
					<input type="checkbox" name="toggle" value="" onClick="checkAll(<?php echo count($rows); ?>);" />
				</th>
				<th nowrap="nowrap" width="50%">
					<?php echo JHTML::_('grid.sort', 'BB_NAME', 'c.name', @$lists['filter_order_Dir'], @$lists['filter_order'], 'joobb_config_view'); ?>
				</th>
				<th width="40%">
					<?php echo JHTML::_('grid.sort', 'BB_DESIGN', 'design_name', @$lists['filter_order_Dir'], @$lists['filter_order'], 'joobb_config_view'); ?>
				</th>														
				<th width="5%">
					<?php echo JText::_('BB_DEFAULT'); ?>
				</th>																																		
				<th nowrap="nowrap" width="1%">
					<?php echo JHTML::_('grid.sort', 'BB_ID', 'c.id', @$lists['filter_order_Dir'], @$lists['filter_order'], 'joobb_config_view'); ?>
				</th>			
			</tr></thead>
			<tfoot>
				<td colspan="20">
					<?php echo $pageNav->getListFooter(); ?>
				</td>
			</tfoot>			
			<tbody><?php
			$k = 0;
			for ($i=0, $n=count($rows); $i < $n; $i++) {
				$row 	=& $rows[$i];
				
				$img_default = $row->default_config ? JOOBB_ADMINIMAGES_LIVE.DL.'menu'.DL.'icon-16-default.png' : JOOBB_ADMINIMAGES_LIVE.DL.'menu'.DL.'spacer.png';
				$alt_default = $row->default_config ? JText::_('BB_DEFAULT') :  JText::_('BB_NOTDEFAULT');
								
				$link = 'index.php?option=com_joobb&task=joobb_config_edit&cid[]='. $row->id .'&hidemainmenu=1';
				
				$checked = JHTML::_('grid.checkedout', $row, $i); ?>
				<tr class="<?php echo "row$k"; ?>">
					<td><?php echo $i+1 ?></td>
					<td><?php echo $checked; ?></td>
					<td><?php
					if (JTable::isCheckedOut($user->get ('id'), $row->checked_out)) {
						echo $row->name;
					} else {
						?>
						<a href="<?php echo JRoute::_($link); ?>">
							<?php echo htmlspecialchars($row->name, ENT_QUOTES); ?>
						</a>
						<?php
					} ?>
					</td>
					<td><?php echo $row->design_name; ?></td>															
					<td align="center">
						<img src="<?php echo $img_default; ?>" width="16" height="16" border="0" alt="<?php echo $alt_default; ?>" />
					</td>																																																												
					<td><?php echo $row->id; ?></td>
				</tr><?php
				$k = 1 - $k;
			} ?>
			</tbody>
			</table>
			<input type="hidden" name="option" value="com_joobb" />
			<input type="hidden" name="task" value="joobb_config_view" />
			<input type="hidden" name="hidemainmenu" value="0" />
			<input type="hidden" name="filter_order" value="<?php echo $lists['filter_order']; ?>" />
			<input type="hidden" name="filter_order_Dir" value="" />
		</form>
		<?php
	}
	
	/**
	 * edit config
	 */
	function editConfig(&$row, &$lists) {
		global $mainframe;
		
		$document =& JFactory::getDocument();
		$document->addStyleSheet(JOOBB_ADMINCSS_LIVE.DL.'icon.css'); ?>
		<script language="javascript" type="text/javascript">
		function submitbutton(pressbutton) {
			var form = document.adminForm;
			if (pressbutton == 'joobb_config_cancel') {
				submitform(pressbutton);
				return;
			}
			var r = new RegExp("[\<|\>|\"|\'|\%|\;|\(|\)|\&|\+|\-]", "i");

			// do field validation
			if (trim(form.name.value) == "") {
				alert("<?php echo JText::sprintf('BB_MSGFIELDREQUIRED', JText::_('BB_NAME'), JText::_('BB_CONFIG')); ?>");
			} else {
				submitform( pressbutton );
			}
		}
		</script>
		<form action="index.php" method="post" name="adminForm">
			<div class="col width-50">
				<fieldset class="adminform">
					<legend><?php echo JText::_('BB_CONFIGDETAILS'); ?></legend>		
					<table class="admintable" cellspacing="1"><tr>
						<td class="key">
							<label for="name" class="hasTip" title="<?php echo JText::_('BB_NAME') .'::'. JText::_('BB_CONFIGNAMEDESC'); ?>">
								<?php echo JText::_('BB_NAME'); ?>
							</label>
						</td>
						<td>
							<input type="text" name="name" id="name" class="inputbox" size="50" value="<?php echo $row->name; ?>" maxlength="255" />
						</td>
					</tr><tr>
						<td class="key">
							<label for="default_config" class="hasTip" title="<?php echo JText::_('BB_DEFAULT') .'::'. JText::_('BB_CONFIGDEFAULTDESC'); ?>">
								<?php echo JText::_('BB_DEFAULT'); ?>
							</label>
						</td>
						<td><?php echo $lists['defaultconfig']; ?></td>
					</tr><tr>
						<td class="key">
							<label for="id_design" class="hasTip" title="<?php echo JText::_('BB_DESIGN') .'::'. JText::_('BB_CONFIGDESIGNDESC'); ?>">
								<?php echo JText::_('BB_DESIGN'); ?>
							</label>
						</td>
						<td><?php echo $lists['designs']; ?></td>
					</tr><tr>
						<td class="key">
							<label for="editor" class="hasTip" title="<?php echo JText::_('BB_EDITOR') .'::'. JText::_('BB_CONFIGEDITORDESC'); ?>">
								<?php echo JText::_('BB_EDITOR'); ?>
							</label>
						</td>
						<td><?php echo $lists['editors']; ?></td>
					</tr><tr>
						<td class="key">
							<label for="id_topic_icon" class="hasTip" title="<?php echo JText::_('BB_DEFAULTTOPICICON') .'::'. JText::_('BB_CONFIGDEFAULTTOPICICONDESC'); ?>">
								<?php echo JText::_('BB_DEFAULTTOPICICON'); ?>
							</label>
						</td>
						<td><?php echo $lists['topicicons']; ?></td>
					</tr><tr>
						<td class="key">
							<label for="id_post_icon" class="hasTip" title="<?php echo JText::_('BB_DEFAULTPOSTICON') .'::'. JText::_('BB_CONFIGDEFAULTPOSTICONDESC'); ?>">
								<?php echo JText::_('BB_DEFAULTPOSTICON'); ?>
							</label>
						</td>
						<td><?php echo $lists['posticons']; ?></td>
					</tr></table>		
				</fieldset>
				<fieldset class="adminform">
					<legend><?php echo JText::_('BB_BOARDSETTINGS'); ?></legend>
					<table class="admintable"><tr>
						<td><?php echo $lists['board_settings']->render('board_settings'); ?></td>
					</tr></table>		
				</fieldset>
				<fieldset class="adminform">
					<legend><?php echo JText::_('BB_LATESTPOSTSETTINGS'); ?></legend>
					<table class="admintable"><tr>
						<td><?php echo $lists['latestpost_settings']->render('latestpost_settings'); ?></td>
					</tr></table>		
				</fieldset>
				<fieldset class="adminform">
					<legend><?php echo JText::_('BB_ATTACHMENTS'); ?></legend>
					<table class="admintable"><tr>
						<td><?php echo $lists['attachment_settings']->render('attachment_settings'); ?></td>
					</tr></table>
				</fieldset>
			</div>
			<div class="col width-50">
				<fieldset class="adminform">
					<legend><?php echo JText::_('BB_VIEWSETTINGS'); ?></legend>
					<table class="admintable"><tr>
						<td><?php echo $lists['view_settings']->render('view_settings'); ?></td>
					</tr></table>		
				</fieldset>
				<fieldset class="adminform">
					<legend><?php echo JText::_('BB_REGISTRATIONUSERSETTINGSDEFAULTS'); ?></legend>
					<table class="admintable"><tr>
						<td><?php echo $lists['user_settings_defaults']->render('user_settings_defaults'); ?></td>
					</tr></table>		
				</fieldset>
				<fieldset class="adminform">
					<legend><?php echo JText::_('BB_CAPTCHASETTINGS'); ?></legend>
					<table class="admintable"><tr>
						<td><?php echo $lists['captcha_settings']->render('captcha_settings'); ?></td>
					</tr></table>		
				</fieldset>
				<fieldset class="adminform">
					<legend><?php echo JText::_('BB_FEEDSETTINGS'); ?></legend>
					<table class="admintable"><tr>
						<td><?php echo $lists['feed_settings']->render('feed_settings'); ?></td>
					</tr></table>		
				</fieldset>
				<fieldset class="adminform">
					<legend><?php echo JText::_('BB_PARSESETTINGS'); ?></legend>
					<table class="admintable"><tr>
						<td><?php echo $lists['parse_settings']->render('parse_settings'); ?></td>
					</tr></table>
				</fieldset>
			</div>
			<div class="clr"></div>				
			<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
			<input type="hidden" name="option" value="com_joobb" />
			<input type="hidden" name="task" value="" />
		</form><?php
	}
}
?>