<?php
/**
 * @version $Id: emotionset.php 448 2009-02-02 22:34:42Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2009 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */
 
// no direct access
defined('_JEXEC') or die('Restricted access');

/**
 * Joo!BB Emotion Set View
 *
 * @package Joo!BB
 */
class ViewEmotionSet {

	/**
	 * show emotion sets
	 */	
	function showEmotionSets(&$rows, $pageNav) {
		global $mainframe;
		
		// initialize variables
		$user	=& JFactory::getUser();
		
		$document =& JFactory::getDocument();
		$document->addStyleSheet(JOOBB_ADMINCSS_LIVE.DL.'icon.css');
		
		$task	= JRequest::getVar('task');
		?>
		<div id="submenu-box">
			<div class="t">
				<div class="t">
					<div class="t">
					</div>
				</div>
			</div>		
			<div class="m">
				<ul id="submenu">
					<li>
						<?php $class = ($task == 'joobb_design_view') ? 'class="active"' : ''; ?>
						<a <?php echo $class; ?> href="index.php?option=com_joobb&task=joobb_design_view"><?php echo JText::_('BB_DESIGNS'); ?></a>
					</li>
					<li>
						<?php $class = ($task == 'joobb_template_view') ? 'class="active"' : ''; ?>
						<a <?php echo $class; ?> href="index.php?option=com_joobb&task=joobb_template_view"><?php echo JText::_('BB_TEMPLATES'); ?></a>
					</li>
					<li>
						<?php $class = ($task == 'joobb_style_view') ? 'class="active"' : ''; ?>
						<a <?php echo $class; ?> href="index.php?option=com_joobb&task=joobb_style_view"><?php echo JText::_('BB_STYLES'); ?></a>
					</li>					
					<li>
						<?php $class = ($task == 'joobb_emotionset_view') ? 'class="active"' : ''; ?>
						<a <?php echo $class; ?> href="index.php?option=com_joobb&task=joobb_emotionset_view"><?php echo JText::_('BB_EMOTIONSETS'); ?></a>
					</li>
					<li>
						<?php $class = ($task == 'joobb_buttonset_view') ? 'class="active"' : ''; ?>
						<a <?php echo $class; ?> href="index.php?option=com_joobb&task=joobb_buttonset_view"><?php echo JText::_('BB_BUTTONSETS'); ?></a>
					</li>
					<li>
						<?php $class = ($task == 'joobb_iconset_view') ? 'class="active"' : ''; ?>
						<a <?php echo $class; ?> href="index.php?option=com_joobb&task=joobb_iconset_view"><?php echo JText::_('BB_ICONSETS'); ?></a>
					</li>													
				</ul>
				<div class="clr"></div>
			</div>
			<div class="b">
				<div class="b">
					<div class="b">
					</div>
				</div>
			</div>
		</div>
		<form action="index.php?option=com_joobb" method="post" name="adminForm">
			<table class="adminlist" cellspacing="1">
			<thead>
				<tr>
					<th nowrap="nowrap" width="5">
						<?php echo JText::_('Num'); ?>
					</th>
					<th nowrap="nowrap" width="5">
						<input type="checkbox" name="toggle" value="" onClick="checkAll(<?php echo count($rows); ?>);" />
					</th>
					<th nowrap="nowrap" width="45%">
						<?php echo JText::_('BB_NAME'); ?>
					</th>					
					<th width="5%">
						<?php echo JText::_('BB_DEFAULT'); ?>
					</th>					
					<th width="10%" align="center">
						<?php echo JText::_('BB_VERSION'); ?>
					</th>
					<th width="10%" class="title">
						<?php echo JText::_('BB_DATE'); ?>
					</th>																													
					<th width="25%" class="title">
						<?php echo JText::_('BB_AUTHOR'); ?>
					</th>			
				</tr>
			</thead>
			<tfoot>
				<td colspan="20">
					<?php echo $pageNav->getListFooter(); ?>
				</td>
			</tfoot>			
			<tbody>
			<?php
			$k = 0;
			for ($i=0, $n=count($rows); $i < $n; $i++) {
				$row 	=& $rows[$i];
				
				if (isset($row->authorUrl) && $row->authorUrl != '') {
					if (isset($row->author) && $row->author != '') {
						$row->author = '<a href="'. $row->authorUrl .'" target="_blank">'. $row->author .'</a>';
					} else {
						$row->author = '<a href="'. $row->authorUrl .'" target="_blank">'. str_replace('http://', '', $row->authorUrl) .'</a>';
					}
				}
				
				$img_default = $row->default_emotion_set ? JOOBB_ADMINIMAGES_LIVE.DL.'menu'.DL.'icon-16-default.png' : JOOBB_ADMINIMAGES_LIVE.DL.'menu'.DL.'spacer.png';
				$alt_default = $row->default_emotion_set ? JText::_('BB_DEFAULT') :  JText::_('BB_NOTDEFAULT');				

				$link = 'index.php?option=com_joobb&task=joobb_emotionset_edit&cid[]='. $row->file_name .'&hidemainmenu=1';																																		
				?>
				<tr class="<?php echo "row$k"; ?>">
					<td>
						<?php echo $pageNav->getRowOffset($i); ?>
					</td>
					<td>
						<input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->file_name; ?>" onclick="isChecked(this.checked);" />
					</td>
					<td>
						<?php
							if (JTable::isCheckedOut($user->get('id'), $row->checked_out)) {
								echo $row->name;
							} else {
								?>
								<a href="<?php echo JRoute::_($link); ?>">
									<?php echo htmlspecialchars($row->name, ENT_QUOTES); ?>
								</a>
								<?php
							}
						?>				
					</td>	
					<td align="center">
						<img src="<?php echo $img_default; ?>" width="16" height="16" border="0" alt="<?php echo $alt_default; ?>" />
					</td>
					<td align="center">
						<?php echo $row->version; ?>
					</td>
					<td>
						<?php echo $row->creationdate; ?>
					</td>																																																							
					<td>
						<?php echo $row->author; ?>
					</td>
				</tr>
				<?php
				$k = 1 - $k;
			}
			?>
			</tbody>
			</table>
			<input type="hidden" name="option" value="com_joobb" />
			<input type="hidden" name="task" value="joobb_emotionset_view" />
			<input type="hidden" name="boxchecked" value="0" />
			<input type="hidden" name="hidemainmenu" value="0" />
		</form>
		<?php
	}
	
	/**
	 * edit emotion set
	 */
	function editEmotionSet(&$joobbEmotionSet) {
		global $mainframe;
		
		$document =& JFactory::getDocument();
		$document->addStyleSheet(JOOBB_ADMINCSS_LIVE.DL.'icon.css');

		?>
		<script language="javascript" type="text/javascript">
			function submitbutton(pressbutton) {
				var form = document.adminForm;
				if (pressbutton == 'joobb_emotionset_cancel') {
					submitform(pressbutton);
					return;
				}
				submitform(pressbutton);
			}
		</script>
		<form action="index.php" method="post" name="adminForm">
			<div class="col width-50">
				<fieldset class="adminform">
					<legend>
						<?php echo JText::_('BB_EMOTIONSETDETAILS'); ?>
					</legend>
					<table class="admintable" cellspacing="1">
						<tr>
							<td class="key">
								<label for="name">
									<?php echo JText::_('BB_NAME'); ?>
								</label>
							</td>
							<td>
								<input type="text" name="name" id="name" class="inputbox" size="50" value="<?php echo $joobbEmotionSet->name; ?>" maxlength="255" readonly="true" />
							</td>						
						</tr>						
					</table>
				</fieldset>
			</div>
			<div class="col width-50">
				<fieldset class="adminform">
					<legend>
						<?php echo JText::_('BB_EMOTIONSET'); ?>
					</legend>
					<table class="admintable" cellspacing="1">
					<?php
					$k = 0;
					for ($i=0, $n=count($joobbEmotionSet->emotions); $i < $n; $i++) {
						$emotion =& $joobbEmotionSet->emotions[$i];
					?>	
						<tr>
							<td class="key">
								<?php echo JText::_($emotion->emotion); ?>
							</td>
							<td>
								<img src="<?php echo $emotion->fileName; ?>" title="<?php echo JText::_($emotion->emotion); ?>" class="joobbEmotion" />
							</td>						
						</tr>
						<?php
					}
					?>						
					</table>
				</fieldset>
			</div>		
			<div class="clr"></div>				
			<input type="hidden" name="id" value="<?php echo $joobbEmotionSet->xmlFile; ?>" />
			<input type="hidden" name="option" value="com_joobb" />
			<input type="hidden" name="task" value="" />
		</form>
	<?php
	}
			
}
?>