<?php
/**
 * @version $Id: view.html.php 485 2009-02-16 15:57:12Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2008 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

/**
 * Joo!BB Information View
 *
 * @package Joo!BB
 */
class JoobbViewInformation extends JView
{

	function display($tpl = null) {
		global $mainframe;

		// initialize variables
		$joobbUser = JoobbUser::getInstance(JRequest::getVar('user', 0));
		$this->assignRef('joobbUser', $joobbUser);
		
		$info = JRequest::getVar('info');
		$this->assignRef('info', $info);

		// handle page title
		$this->document->setTitle(JText::_('BB_INFORMATION'));
		
		// handle metadata
		$this->document->setDescription($this->joobbConfig->getBoardSettings('description'));
		$this->document->setMetadata('keywords', $this->joobbConfig->getBoardSettings('keywords'));
		
		// handle bread crumb
		$this->breadCrumbs->addBreadCrumb(JText::_('BB_INFORMATION'), '');
		
		$this->assignRef('boardIndexLink', JRoute::_('index.php?option=com_joobb&view=board&Itemid='.$this->Itemid));
		$this->assignRef('loginLink', JRoute::_('index.php?option=com_joobb&view=login&Itemid='.$this->Itemid));
		$this->assignRef('requestLoginLink', JRoute::_('index.php?option=com_joobb&view=requestlogin&Itemid='.$this->Itemid));		

		parent::display($tpl);
	}
	
	function loadInformation() {
		global $mainframe;
		
		// initialize variables
		$infoFile = $this->templatePath.DS.'information'.DS;
		
		switch($this->info) {
			case 'account_activation':
				switch($this->joobbConfig->getBoardSettings('account_activation')) {
					case 0:		// no activation needed
						$infoFile .= $this->info.'_no.php';
						break;
					case 1:		// activation by user
						$infoFile .= $this->info.'_user.php';
						break;
					case 2:		// activation by admin
						$infoFile .= $this->info.'_admin.php';
						break;				
				}			
				break;
			default:
				$infoFile .= $this->info.'.php';
				break;				 
		}

		jimport('joomla.filesystem.file');
		if (JFile::exists($infoFile)) {
			include $infoFile;
		} else {
			JError::raiseError(500, JText::sprintf('BB_MSGFILENOTFOUND', $infoFile)); 
		}
	}
	
}
?>