<?php
/**
 * @version $Id: view.html.php 528 2009-03-12 14:05:30Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2008 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

/**
 * Joo!BB Move Topic View
 *
 * @package Joo!BB
 */
class JoobbViewMoveTopic extends JView
{

	function display($tpl = null) {
		global $mainframe;

		// initialize variables
		$joobbAuth		=& JoobbAuth::getInstance();
		$topicId		= JRequest::getVar('topic', 0, '', 'int');

		if (!$topicId) {
			$this->messageQueue->addMessage(JText::_('BB_MSGREQUESTNOTPERFORMED'));
			$mainframe->redirect(JRoute::_('index.php?option=com_joobb&view=board&Itemid='. $this->Itemid, false));
		}
		
		$model	=& $this->getModel();
		$topic = $model->getTopic($topicId);
		$this->assignRef('topic', $topic);
		$post = $model->getPost($topic->id_first_post);
		$this->assignRef('post', $post);
		
		if ($this->joobbUser->getRole($topic->id_forum) < 2) {
			$this->messageQueue->addMessage(sprintf(JText::_('BB_MSGNOPERMISSION'), JText::_('BB_MSGMOVETOPIC')));
			$mainframe->redirect(JRoute::_('index.php?option=com_joobb&view=topic&topic='.$topicId.'&Itemid='. $this->Itemid, false));
		}
		
		$forums = $model->getForums($topic->id_forum);
		$this->assignRef('forums', $forums);
		
		// load form validation behavior
		JHTML::_('behavior.formvalidation');
		
		// handle page title
		$this->document->setTitle(JText::_('BB_MOVETOPIC'));
		
		// handle bread crumb
		$this->breadCrumbs->addBreadCrumb(JText::_('BB_MOVETOPIC'), '');
		
		$action = 'index.php?option=com_joobb&task=joobbmovetopic&topic='.$topicId.'&Itemid='. $this->Itemid;
		$this->assignRef('action', $action);
		
		// get buttons
		$joobbButtonSet	=& JoobbButtonSet::getInstance();
		$this->assignRef('buttonSubmit', $joobbButtonSet->buttonByFunction['buttonSubmit']);
		$this->assignRef('buttonCancel', $joobbButtonSet->buttonByFunction['buttonCancel']);
				
		parent::display($tpl);
	}
	
	function &getForum($index = 0) {
		$forum =& $this->forums[$index];
		return $forum;
	}
	
}
?>