<?php
/**
 * @version $Id: view.html.php 581 2009-08-16 19:21:18Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2008 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

/**
 * Joo!BB Topic View
 *
 * @package Joo!BB
 */
class JoobbViewTopic extends JView
{

	function display($tpl = null) {
		global $mainframe;

		// initialize variables
		$topicId = JRequest::getVar('topic', 0, '', 'int');
		
		if (!$topicId) {
			$this->messageQueue->addMessage(JText::_('BB_MSGREQUESTNOTPERFORMED'));
			$link = JRoute::_('index.php?option=com_joobb&view=board&Itemid='. $this->Itemid, false);
			$mainframe->redirect($link);
		}
		
		$model		=& $this->getModel();
		$topic		= $model->getTopic($topicId);
		$this->assignRef('topic', $topic);
		$forum		= $model->getForum($topic->id_forum);
		
		// check if user can read this topic
		if ($forum->auth_read > $this->joobbUser->getRole($forum->id)) {
			$this->messageQueue->addMessage(sprintf(JText::_('BB_MSGNOPERMISSION'), JText::_('BB_MSGREADTOPIC')));
			$mainframe->redirect(JRoute::_('index.php?option=com_joobb&view=board&Itemid='. $this->Itemid, false));
		}		
		
		$firstpost = $model->getFirstPost($topic->id_first_post);
		$this->assignRef('firstpost' , $firstpost);
		
		// request variables
		$limit		= JRequest::getVar('limit', $this->joobbConfig->getBoardSettings('posts_per_page'), '', 'int');
		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');

		// handle page title
		$this->document->setTitle($forum->name.' - '.$firstpost->subject);
		
		// handle metadata
		$this->document->setDescription($forum->name.' - '.$firstpost->subject);
		$this->document->setMetadata('keywords', str_replace(' ', ', ', $firstpost->subject));
		
		// increment hit			
		$model->incrementHit($topic->id);
		
		// set data model
		$posts	= new JoobbPost($this->get('posts'));
		$this->assignRef('posts', $posts);

		// handle bread crumb
		$redirect = 'index.php?option=com_joobb&view=forum&forum='.$forum->id.'&Itemid='.$this->Itemid;
		$this->breadCrumbs->addBreadCrumb($forum->name, $redirect);
		$this->breadCrumbs->addBreadCrumb($firstpost->subject, '');
		
		// total posts
		$this->assignRef('total', $this->get('total'));
			
		$showPagination = false;
		if ($this->total > $limit) {
			$showPagination = true;
		}
		$this->assign('showPagination', $showPagination);
			
		jimport('joomla.html.pagination');
		$this->pagination = new JPagination($this->total, $limitstart, $limit);

		$joobbButtonSet	=& JoobbButtonSet::getInstance();
		
		if ($forum->locked || $topic->status == 1) {
			if ($forum->locked) {
				$msg = sprintf(JText::_('BB_MSGFORUMLOCKED'), $forum->name);
				$this->messageQueue->addMessage($msg);
			}
			// ToDo: Desing a new button locked! REMOVE JoobbHelper::getButtonFolder() when buttons are done!
			$buttonNewPost = $joobbButtonSet->buttonByFunction['buttonPostReply'];		
			$buttonNewPost->href = '';
		} else {
			$buttonNewPost = $joobbButtonSet->buttonByFunction['buttonPostReply'];
			$buttonNewPost->href = JRoute::_('index.php?option=com_joobb&view=editpost&topic='.$topic->id.'&post=0&Itemid='.$this->Itemid);
		}		
		$this->assign('buttonNewPost', $buttonNewPost);
		
		$joobbAuth =& JoobbAuth::getInstance();
		$guestTime = $this->joobbConfig->getBoardSettings('guest_time') * 60;

		// lock topic authentification
		$buttonLockTopicToggle = null;		
		if ($joobbAuth->getAuth('auth_lock', $topic->id_forum) || $this->joobbUser->get('id') == $firstpost->id_user && $firstpost->id_user != 0 || 
			$firstpost->id_user == 0 && $firstpost->ip_poster == $_SERVER['REMOTE_ADDR'] && (strtotime(gmdate("Y-m-d H:i:s")) - strtotime($firstpost->date_post)) < $guestTime) {
					
			if ($topic->status != 1) {
				$buttonLockTopicToggle = $joobbButtonSet->buttonByFunction['buttonLockTopic'];
				$buttonLockTopicToggle->href = JRoute::_('index.php?option=com_joobb&task=joobblocktopic&topic='.$topic->id.'&Itemid='.$this->Itemid);
			} else {
				$buttonLockTopicToggle = $joobbButtonSet->buttonByFunction['buttonUnlockTopic'];
				$buttonLockTopicToggle->href = JRoute::_('index.php?option=com_joobb&task=joobbunlocktopic&topic='.$topic->id.'&Itemid='.$this->Itemid);
			}
		}
		$this->assign('buttonLockTopicToggle', $buttonLockTopicToggle);
		
		// move topic authentification
		$buttonMoveTopic = null;
		if ($joobbAuth->getAuth('auth_move', $topic->id_forum)) {
			$buttonMoveTopic = $joobbButtonSet->buttonByFunction['buttonMoveTopic'];
			$buttonMoveTopic->href = JRoute::_('index.php?option=com_joobb&view=movetopic&topic='.$topic->id.'&Itemid='.$this->Itemid);	
		}
		$this->assign('buttonMoveTopic', $buttonMoveTopic);

		$this->assign('attachmentPath', $this->joobbConfig->getAttachmentSettings('attachment_path'));
		
		parent::display($tpl);
	}
}
?>