<?php
/**
 * @version $Id: view.html.php 587 2009-08-17 19:24:26Z robste $
 * @package Joo!BB
 * @copyright Copyright (C) 2007-2008 Sonixsoft. All rights reserved.
 * @license GNU/GPL. Please see license.php in Joo!BB directory 
 * for copyright notices and details.
 * Joo!BB is free software. This version may have been NOT modified.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

/**
 * Joo!BB User Posts View
 *
 * @package Joo!BB
 */
class JoobbViewUserPosts extends JView
{

	function display($tpl = null) {
		global $mainframe;

		// initialize variables
		$userId = JRequest::getVar('id', 0, '', 'int');
		$joobbUserPosts	=& JoobbUser::getInstance($userId);
		$this->assignRef('joobbUserPosts', $joobbUserPosts);

		// request variables
		$limit = JRequest::getVar('limit', $this->joobbConfig->getBoardSettings('posts_per_page'), '', 'int');
		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');
				
		$model	=& $this->getModel();
		$posts	= new JoobbPost($model->getUserPosts($userId, $limitstart, $limit));
		$this->assignRef('posts', $posts);
		$this->assignRef('total', $model->getTotal());
	
		// handle page title
		$this->document->setTitle(JText::sprintf('BB_POSTSFROMUSER', $joobbUserPosts->get('name')));
		
		// handle bread crumb
		$this->breadCrumbs->addBreadCrumb(JText::sprintf('BB_POSTSFROMUSER', $joobbUserPosts->get('name')), '');
		
		// handle pagination
		$showPagination = false;
		if ($this->total > $limit) {
			jimport('joomla.html.pagination');
			$this->pagination = new JPagination($this->total, $limitstart, $limit);
			$showPagination = true;
		}
		$this->assign('showPagination', $showPagination);
		
		$this->assign('attachmentPath', $this->joobbConfig->getAttachmentSettings('attachment_path'));

		parent::display($tpl);
	}
}
?>